#ifndef lint
static char *RCSid = "$Header: dist.c,v 1.1 89/12/14 08:19:41 jay Exp $";
#endif /* not lint */

/*
 * autodist.c
 *
 * automatically set up distribution routes from a range
 * of sectors to a specific sector 
 *
 * Dave Pare, 1986
 */

#include "misc.h"
#include "var.h"
#include "xy.h"
#include "sect.h"
#include "nsc.h"
#include "nat.h"
#include "file.h"
#include "path.h"

int legalpath();
int legaldest();

/*
 * autodistribute <SECT> <TARGET SECT> [SECTOR TYPES]
 */
adis()
{
	extern	char *argp[];
	extern	int aborted;
	struct	sctstr sect,target;
	struct	nstr_sect nstr,tstr;
	char	*p,*t;
	int	i;
	coord	dstx;
	coord	dsty;

	if (!snxtsct(&nstr, argp[1])) {
	    pr("usage: autodistribute <SOURCE COORD> ");
	    pr("<DEST COORD|SECTOR TYPE(S)> ");
	    pr("[PATH SECTOR TYPES]\n");
	    return RET_SYN;
	    }

	if (!(p = getstarg(argp[2], "destination sector : ")))
	    return RET_SYN;

	/*
	**  p points to either a sector coordinate string, or a string
	**  defining the types of sectors that are permissible targets.
	**  Set up the routing constraints.
	*/

	t = (argp[3] && *argp[3]) ? argp[3] : "~ .^\\";

	if (!sarg_xy(p, &dstx, &dsty)) {
	    legalroute(t,p,0,0);
	    i = 0;
	    while (*p) if (typematch(p++,EF_SECTOR) < 0) {
		pr(fmt("Sector type '%c' is invalid\n",*p));
		i++;
	    }	
	    if (i) pr("See \"info sector-types\"\n");
	}
	else {
	    if (!getsect(dstx, dsty, &target)) {
		pr("Can't access destination sector");
		return RET_FAIL;
	    }
	    if (target.sct_own != cnum) {
		pr(fmt("You don't own sector %s!\n",
		       xyas(dstx, dsty, cnum)));
		return RET_FAIL;
	    }
	    if (target.sct_type != SCT_WAREH) {
		pr(fmt("Warning: sector %s not a warehouse!\n",
		       xyas(dstx, dsty, cnum)));
	    }
	    legalroute(t,"",dstx,dsty);
	}

	while (!aborted && nxtsct(&nstr, &sect)) {
		if (!owner) continue;
		pr(fmt("%s at %s : ", dchr[sect.sct_type].d_name,
			xyas(nstr.x, nstr.y, cnum)));

		p = (char *)shortestpath(nstr.x,nstr.y,
					 legaldest,legalpath,10);

		if (strlen(p)>10 || !*p || *p=='?') {
		    pr("no path possible\n");
		    continue;
		}
		strcat(p,"h");
		pr(fmt("%s",p));
		if (chkpath(cnum, p, nstr.x, nstr.y) == 0)
			pr(" (path not fully yours)");
		pr("\n");
		getsect(nstr.x, nstr.y, &sect);
		sect.sct_distpath = pathtomask(p);
		putsect(&sect);
	}
	return RET_OK;
}
