#ifndef lint
static char *RCSid = "$Header: bomb.c,v 1.1 89/12/14 08:19:16 jay Exp $";
#endif

/*
 * pinp.c
 *
 * Pinpoint bombing mission
 *
 * Dave Pare, 1986
 */

#include <ctype.h>
#include "misc.h"
#include "var.h"
#include "sect.h"
#include "ship.h"
#include "item.h"
#include "plane.h"
#include "nuke.h"
#include "xy.h"
#include "nsc.h"
#include "news.h"
#include "file.h"
#include "nat.h"
#include "path.h"

static	pin_bomb();
static	nuke_bomb();
static	strat_bomb();

static	comm_bomb();
static	plane_bomb();
static	veh_bomb();
static	eff_bomb();

extern double effbomb_mult;
extern double effbomb_subt;
extern int pinbomb_base;
extern int pinbomb_range;

bomb()  { labomba(0); }
kbomb() { labomba(1); }

labomba(kamikaze)
int kamikaze;
{
	extern	char *argp[];
	char	*p;
	int	mission_flags;
	coord	tx, ty;
	coord	ax, ay;
	int	ap_to_target;
	struct	ichrstr *ip;
	char	flightpath[256];
	struct	nstr_item ni_bomb;
	struct	nstr_item ni_esc;
	coord	x, y;
	struct	sctstr target;
	struct	qelem bomb_list;
	struct	qelem esc_list;
	int	wantflags;
	struct	sctstr ap_sect;
	char	mission;

	wantflags = 0;
	if (!snxtitem(&ni_bomb, EF_PLANE, argp[1]))	return RET_SYN;
	if (!snxtitem(&ni_esc, EF_PLANE, argp[2]))	pr("No escorts...\n");
	if (!(p = getstarg(argp[3], "pinpoint, strategic, or nuclear? ")))
	    return RET_SYN;
	mission = *p;
	if (!index("psn", (mission = *p)))		return RET_SYN;
	if (!getassemblypoint(argp[1],argp[4],&x,&y))	return RET_SYN;
	if (!getsect(x, y, &ap_sect))			return RET_SYN;

#ifndef ASSEMBLEANYWHERE
	if (ap_sect.sct_own && ap_sect.sct_own != cnum) {
		pr("Assembly point not owned by you!\n");
		return RET_SYN;
	}
#endif
	ax = x;
	ay = y;
	p = getpath(argp[5], ax, ay, 0, 0, 0);
	if (!p || !*p)
	    return RET_SYN;

	(void)strcpy(flightpath, p);
	tx = ax;
	ty = ay;
	(void) pathtoxy(flightpath, &tx, &ty, fcost);
	pr(fmt("target sector is %s\n", xyas(tx, ty, cnum)));
	getsect(tx, ty, &target);
	if (target.sct_type == SCT_SANCT) {
		pr("You can't bomb that sector!\n");
		return RET_SYN;
	}
	ip = 0;
	ap_to_target = strlen(flightpath);
	pr(fmt("range to target is %d\n", ap_to_target));
	/*
	 * select planes within range
	 */
	pln_sel(&ni_bomb, &bomb_list, &ap_sect, ap_to_target,
		2, wantflags, P_M|P_O, kamikaze ? "*" : (char *)0);
	pln_sel(&ni_esc, &esc_list, &ap_sect, ap_to_target,
		2, P_F, P_M|P_O, (char *)0);
	/*
	 * now arm and equip the bombers, transports, whatever.
	 * tech is stored in high 16 bits of mission_flags.
	 * yuck.
	 */
	mission_flags = 0x7fff0000;
	mission_flags |= P_X;		/* stealth (shhh) */
	mission_flags = pln_arm(&bomb_list, mission, ip, 0, mission_flags);
	if (QEMPTY(&bomb_list)) {
		pr("No planes could be equipped for the mission.\n");
		return RET_FAIL;
	}
	mission_flags = pln_arm(&esc_list, mission, ip, P_F, mission_flags);
	ac_encounter(&bomb_list, &esc_list, ax, ay, flightpath, mission_flags);
	if (QEMPTY(&bomb_list)) {
		pr(fmt("No planes got through fighter defenses\n"));
	} else {
		getsect(tx, ty, &target);
		switch (mission) {
		case 'p':
			pin_bomb(&bomb_list, &target);
			putsect(&target);
			break;
		case 'n':
			nuke_bomb(&bomb_list, &target);
			break;
		case 's':
			nreport(cnum, N_SCT_BOMB, target.sct_own, 1);
			strat_bomb(&bomb_list, &target);
			putsect(&target);
			break;
		default:
			pr(fmt("Bad mission %c\n", mission));
			break;
		}
	}
	pln_unequip(&bomb_list); /* unload undropped bombs */
	pln_put(&bomb_list);
	pln_put(&esc_list);
	return RET_OK;
}

static pin_bomb(list, target)
struct	qelem *list;
struct	sctstr *target;
{
    extern char *effadv();
    extern int aborted;
    struct dchrstr *dcp;
    int	nplanes,ntanks,nballoons,ntrains,nships;
    int	i,type,bad,subspotter;
    char *p,*s,*t;
    char buf[128];
    int	vec[I_MAX+1];
    struct qelem *qp;
    struct plist *plp;

    bad = 0;
    type = target->sct_type;
    dcp = &dchr[type];
    pr(fmt("Target sector is a %s constructed %s\n", 
	   effadv((int)target->sct_effic), dcp->d_name));
    
    /* Check the plane list to see if anyone can see subs */
    subspotter = 0;
    for (qp = list->q_forw; qp!=list && !subspotter; qp=qp->q_forw) {
	plp = (struct plist *) qp;
	subspotter = (plp->pcp->pl_flags & P_U);
    }
    
    strcpy(buf,"Bomb what\n(");
    s = &buf[11];
    
    nships = shipsatxy(target->sct_x,target->sct_y,0,subspotter?0:M_SUB);
    if (nships) strcat(buf,", ship");
    
#ifdef TANKS
    ntanks = tanksatxy(target->sct_x,target->sct_y,0,0);
    if (ntanks) strcat(buf,", tank");
#endif
#ifdef TRAINS
    ntrains = trainsatxy(target->sct_x,target->sct_y,0,0);
    if (ntrains) strcat(buf,", train");
#endif
#ifdef BALLOONS
    nballoons = balloonsatxy(target->sct_x,target->sct_y,0,0);
    if (nballoons) strcat(buf,", balloon");
#endif
#ifdef PLANES
    nplanes = planesatxy(target->sct_x,target->sct_y,0,0);
    if (nplanes) strcat(buf,", plane");
#endif
    if (target->sct_type != SCT_WATER) {
#ifdef BUNKERS
	strcat(buf,", bunker");
#endif
	getvec(VT_ITEM, vec, (char *)target, EF_SECTOR);
	strcat(buf,", efficiency, commodities");
    }
    
    if (*s) {
	for (t=s+2; *s++ = *t++;);
	strcat(buf,") ? ");
    } else {
	pr("No pinpoint bombable targets in this sector\n");
	return;
    }
    
 retry:
    p = getstring(buf);
    
    if (p == 0 || *p == 0) {
	if (aborted || (++bad > 2)) return;
	goto retry;
    }
    switch (*p) {
    case 'p':
	if (!nplanes) {
	    pr("no planes there\n");
	    goto retry;
	}
	plane_bomb(list, target);
	break;
    case 's':
	if (!nships) {
	    pr("no ships there\n");
	    goto retry;
	}
	veh_bomb(list, target, CLASS_SHIP);
	break;
    case 't':
	if (p[1]=='r') i = ntrains ? 1 : 0;
	else i = ntanks ? 3 : 2;
	if (!p[1]) {
	    i = ntanks ? 3 : (ntrains ? 1 : 2);
	}
	if (!(i&1)) {
	    pr(fmt("no %s there\n",i&2 ? "tanks" : "trains"));
	    goto retry;
	}
	if (i&2) veh_bomb(list, target, CLASS_TANK);
	else veh_bomb(list, target, CLASS_TRAIN);
	break;
    case 'b':
	if (p[1]=='u') i = (target->sct_type!=SCT_WATER) ? 1 : 0;
	else i = nballoons ? 3 : 2;
	if (!p[1]) {
	    i = nballoons ? 3 : ((target->sct_type!=SCT_WATER) ? 1 : 2);
	}
	if (!(i&1)) {
	    pr(fmt("no %s there\n",i&2 ? "balloons" : "bunker"));
	    goto retry;
	}
	if (i&2) veh_bomb(list, target, CLASS_BALLOON);
	else bunker_bomb(list, target);
	break;
    case 'c':
	if (!vec[I_SHELL] && !vec[I_GUN] && !vec[I_MILIT] &&
	    !vec[I_PETROL] && !vec[I_OIL] && !vec[I_RAD]) {
	    pr(fmt("No bombable commodities in %s\n",
		   xyas(target->sct_x, target->sct_y, cnum)));
	    goto retry;
	}
	comm_bomb(list, target);
	break;
    case 'e':
	if (target->sct_type == SCT_WATER) {
	    pr("no efficiency there\n");
	    goto retry;
	}
	eff_bomb(list, target);
	break;
    case 'q':
	pr("Aborting mission.\n");
	return;
    default:
	pr("Bad target type.\n");
	goto retry;
    }
}

static eff_bomb(list, target)
struct	qelem *list;
struct	sctstr *target;
{
    register struct plist *plp;
    float eff;
    int	bombs;
    struct qelem *qp;
    int	i;
    
    eff = 1.0;
    for (qp = list->q_forw; qp != list; qp = qp->q_forw) {
	plp = (struct plist *) qp;
	if (plp->pcp->pl_flags & P_C)
	    continue;
	bombs = plp->bombs;
	for (i=0; i<bombs; i++) {
	    if (i)
		pr("-");
	    if (roll(100) > plp->pcp->pl_acc) {
		eff *= effbomb_mult; /* 0.88; */
		eff -= effbomb_subt; /* 0.00; */
		pr("HIT");
	    } else
		pr("miss");
	}
	pr("\n");
	plp->bombs = 0;
    }
    if (eff < 0.0) eff = 0.0;
    target->sct_effic = (target->sct_effic * eff);
    pr(fmt("did %.2f%% damage to efficiency in %s\n",
	   100.0 - (eff*100), xyas(target->sct_x, target->sct_y, cnum)));
    wu(0, target->sct_own, 
       fmt("%s bombing raid did %.2f%% damage in %s",
	   cname(cnum), 100.0 - (eff*100),
	   xyas(target->sct_x, target->sct_y, target->sct_own)));
}

#ifdef BUNKERS
static bunker_bomb(list, target)
struct	qelem *list;
struct	sctstr *target;
{
    register struct plist *plp;
    struct natstr *natp;
    float eff,coll;
    int	flaws,i,j,k,bombs,amt;
    int	bunkersize,tlev,above,below;
    struct ichrstr *ip;
    struct qelem *qp;
    
    bunkersize = target->sct_harden;
    coll = eff = 100.0;
    natp = getnatp(target->sct_own);
    tlev = (int) natp->nat_level[NAT_TLEV];
    flaws = (int)(8.0 * (50.0 / (50.0 + tlev)) + 0.5);
    if (!flaws) flaws = 1;
    for (qp = list->q_forw; qp != list; qp = qp->q_forw) {
	plp = (struct plist *) qp;
	if (plp->pcp->pl_flags & P_C) continue;
	bombs = plp->bombs;
	for (i=0; i<bombs; i++) {
	    if (i) pr("-");
	    /* Since bunkers are hidden, we don't give any feedback
	       to let the attacker know when he's scored a hit */
	    if (roll(100) > plp->pcp->pl_acc) {
		eff *= (100 - (roll(flaws) + flaws)) / 100.0;
		coll *= 0.99;
	    } else
		coll *= 0.98;
	    pr("boom");
	}
	pr("\n");
	plp->bombs = 0;
    }
    amt = getvar(V_MILIT, (char *)target, EF_SECTOR);
    above = amt-bunkersize;	
    if (above<0) above = 0;
    below = amt-above;
    dpr(fmt("%d mil on surface, %d mil in %d capacity bunker",
	    above,below,bunkersize));
    i = above-(above*coll/100.0); /* surface casualties */
    j = below-(below*eff/100.0); /* bunker losses */
    k = bunkersize-(bunkersize*eff/100.0); /* bunker damage */
    dpr(fmt("%.2f%% eff, %.2f%% coll",eff,coll));
    dpr(fmt("%d die above, %d die in bunker, %d bunker damage",i,j,k));
    amt -= (i+j); if (amt<0) amt = 0;
    target->sct_harden -= k;
    putvar(V_MILIT, amt, (char *)target, EF_SECTOR);
    sectdamage(target, (int) (100.0 - coll));
    pr(fmt("did %.2f%% surface mil damage, unknown bunker damage in %s\n",
	   100.0-coll, xyas(target->sct_x, target->sct_y, cnum)));
    nreport(cnum, N_BUNKER_BOMB, target->sct_own, 1);
    wu(0, target->sct_own,
       fmt("%s precision bombing raid did %.2f%% damage to bunker in %s",
	   cname(cnum), 100.0-eff,
	   xyas(target->sct_x,target->sct_y,target->sct_own)));
}
#endif

static int bombcomm[] = { I_SHELL, I_GUN, I_MILIT, I_PETROL, I_OIL, I_RAD };
static int nbomb = sizeof(bombcomm) / sizeof(int);

static comm_bomb(list, target)
struct	qelem *list;
struct	sctstr *target;
{
    register struct plist *plp;
    struct natstr *natp;
    float eff,coll;
    int	bombs,i,j,amt,blownup,bombmil;
    struct ichrstr *ip;
    int	vec[I_MAX+1];
    struct qelem *qp;
    getvec(VT_ITEM, vec, (char *)target, EF_SECTOR);
    for (i=0; i<nbomb; i++) {
	if (vec[bombcomm[i]] == 0)
	    continue;
	ip = &ichr[bombcomm[i]];
	pr(fmt("some %s\n", ip->i_name));
    }
    while ((ip = whatitem((char *)0, "commodity to bomb? ")) == 0) {
	for (i=0; i<nbomb; i++) {
	    if (&ichr[bombcomm[i]] == ip) {
		bombmil = (bombcomm[i]==I_MILIT);
		break;
	    }
	}
	if (i < nbomb) break;
	else {
	    pr(fmt("You can't bomb %s!\n", ip->i_name));
	    for (i=0; i<nbomb; i++) {
		pr(i == 0 ? "Bombable: " : ", ");
		pr(ichr[bombcomm[i]].i_name);
	    }
	    pr("\n");
	}
    }
    eff = coll = 100.0;
    for (qp = list->q_forw; qp != list; qp = qp->q_forw) {
	plp = (struct plist *) qp;
	if (plp->pcp->pl_flags & P_C) continue;
	bombs = plp->bombs;
	for (i=0; i<bombs; i++) {
	    if (i) pr("-");
	    if (roll(100) > plp->pcp->pl_acc) {
		eff *= (100 - (roll(pinbomb_range) + pinbomb_base)) / 100.0;
		coll *= 0.99;
		pr("BLAM");
	    } else {
		coll *= 0.98;
		pr("boom");
	    }
	}
	pr("\n");
	plp->bombs = 0;
    }
    amt = getvar(ip->i_vtype, (char *)target, EF_SECTOR);
#ifdef BUNKERS
    if (bombmil) { /* guys in the bunker are protected */
	int above,below;
	above = amt - target->sct_harden;
	if (above<0) above = 0;
	below = amt - above;
	dpr(fmt("%d mil on surface, %d mil in %d capacity bunker",
		above,below,target->sct_harden));
	blownup = above - (above * eff / 100.0);
    } else
#endif
    blownup = amt - (amt * eff / 100.0);
    amt -= blownup; if (amt<0) amt = 0;
    dpr(fmt("%.2f%% eff, %.2f%% coll",eff,coll));
    dpr(fmt("%d blown up, %d remain",blownup,amt));
    putvar(ip->i_vtype, amt, (char *)target, EF_SECTOR);
    /* this will do some bunker damage as well */
    sectdamage(target, (int) (100.0 - coll));
    pr(fmt("did %.2f%% damage to %s level and %.2f%% damage to %s\n",
	   100.0 - eff, ip->i_name, 100.0 - coll,
	   xyas(target->sct_x, target->sct_y, cnum)));
    nreport(cnum, N_SCT_BOMB, target->sct_own, 1);
    wu(0, target->sct_own,
       fmt("%s precision bombing raid did %.2f%% damage to %s in %s",
	   cname(cnum), 100.0 - eff, ip->i_name,
	   xyas(target->sct_x, target->sct_y, target->sct_own)));
}



static veh_bomb(list, target, vc)
struct	qelem *list;
struct	sctstr *target;
int vc;
{
    extern int aborted;
    struct plist *plp;
    struct mchrstr *mcp;
    struct shpstr ship;
    struct qelem *qp;
    int	bombs,onsea;
    int	acc,vis,dam;
    int	shipno,i,n;
    char *q;
    char buf[80];
    
    onsea = (target->sct_type == SCT_WATER) ? 1 : 0;
    for (qp = list->q_forw; qp != list && !aborted; qp = qp->q_forw) {
	plp = (struct plist *) qp;
	if (plp->pcp->pl_flags & P_C) continue;
	if (!plp->bombs) continue;
	bombs = plp->bombs;
	(void) sprintf(buf, "%s (#%d), %d bombs.  Target? ",
		       plp->pcp->pl_name, plp->plane.pln_uid, bombs);
	shipno = -1;
	while (shipno < 0 && !aborted) {
	    if ((q = getstring(buf)) == 0 || *q == 0) continue;
	    if (*q == '?') {
		vatxy(target->sct_x, target->sct_y,
		      0, (plp->pcp->pl_flags & P_U) ? 0 : M_SUB,
		      vcmask(vc,-1,-1,-1),0);
		continue;
	    }
	    if (*q == 'd') goto next;
	    if (!isdigit(*q)) continue;
	    n = atoi(q);
	    if (n < 0) continue;
	    if (getship(n, &ship) && 
		mchr[ship.shp_type].m_class==vc &&
		ship.shp_x==target->sct_x &&
		ship.shp_y==target->sct_y)
		shipno = n;
	}

	if (shipno < 0) continue;
	mcp = &mchr[ship.shp_type];

	/*
	**  Subs on the surface are sitting ducks.
	**  Subs at periscope depth are harder to spot,
	**  and subs running deep are almost impossible to hit.
	*/

	vis = mcp->m_visib;
	if (issub(&ship) && ship.shp_depth > 0) {
	    if (!(plp->pcp->pl_flags & P_U)) continue;
	    vis = (ship.shp_depth > 1) ? -20 : 0;
	}

	if (isballoon(&ship)) {
	    if (ship.shp_depth>1) continue;
	    vis *= (ship.shp_depth+1);
	}

	/*
	**  Ships on high seas are harder to hit because they're
	**  moving around so much! (and practically impossible to
	**  hit for the poor strategic bombers)
	*/

	acc = plp->pcp->pl_acc - vis + (mcp->m_speed * onsea);
	if ((plp->pcp->pl_flags & P_T) == 0)
	    acc += 35;
	dam = 0;
	if (issub(&ship) && ship.shp_depth>0) pr("splash... ");
	if (roll(100) > acc) {
	    i = roll(bombs) + 1;
	    if (i > bombs) i = bombs;
	    while (i--) {
		pr((issub(&ship) && ship.shp_depth>0) ? "kaFWOOM" : "BLAM");
		if (i) pr("-");
		dam += ((roll(8)+6) * 127) / mcp->m_armor;
	    }
	    pr("\n");
	} else {
	    if (!isship(&ship)) pr("missed\n");
	    else if (ship.shp_depth==0)	pr("splash\n");
	}
	plp->bombs = 0;
	switch (vc) {
	case CLASS_TANK:    i = N_TNK_BOMB; break;
	case CLASS_BALLOON: i = N_BAL_BOMB; break;
	case CLASS_TRAIN:   i = N_TRN_BOMB; break;
	default:	    
	    i = (mchr[ship.shp_type].m_flags & M_SUB) 
		? N_SUB_BOMB : N_SHP_BOMB;
	    break;
	}
	nreport(cnum,i, ship.shp_own, 1);
	if (dam > 100)
	    dam = 100;
	shipdamage(&ship, dam);
	wu(0, ship.shp_own, 
	   fmt("%s bombs did %d%% damage to %s #%d at %s",
	       cname(cnum), 
	       dam, mcp->m_name, ship.shp_uid,
	       xyas(target->sct_x, target->sct_y, ship.shp_own)));
	pr("\n");
	/* 
	**  Submerged subs may jettison floatsam to try to fool 
	**  attacker into thinking the sub's dead.
	*/
	if (ship.shp_effic>=20 && ship.shp_depth>0 && chance(0.1)) {
	    pr(fmt("%s #%d debris spotted!\n",mcp->m_name,ship.shp_uid));
	}
	putship(n, &ship);
    next:
	;
    }
}

static plane_bomb(list, target)
struct	qelem *list;
struct	sctstr *target;
{
    char *q;
    extern int aborted;
    int	planeno,i,n,bombs,acc,dam;
    natid own;
    char buf[80];
    struct plnstr plane;
    struct qelem *qp;
    struct plist *plp;
    
    for (qp = list->q_forw; qp != list; qp = qp->q_forw) {
	plp = (struct plist *) qp;
	if (plp->pcp->pl_flags & P_C) continue;
	bombs = plp->bombs;
	(void) sprintf(buf, "%s (#%d), %d bombs.  Target? ",
		       plp->pcp->pl_name, plp->plane.pln_uid, bombs);
	planeno = -1;
	while (planeno < 0 && !aborted) {
	    if ((q = getstring(buf)) == 0 || *q == 0)
		continue;
	    if (*q == '?') {
		planesatxy(target->sct_x, target->sct_y, 0, 0);
		continue;
	    }
	    if (*q == 'd') goto next;
	    n = atoi(q);
	    if (n < 0) continue;
	    if (getplane(n, &plane) &&
		plane.pln_x == target->sct_x &&
		plane.pln_y == target->sct_y &&
		(plane.pln_flags & PLN_LAUNCHED) == 0)
		planeno = n;
	    else
		pr(fmt("Plane #%d not spotted\n", n));
	}
	if (planeno < 0)
	    continue;
	dam = 0;
	acc = plp->pcp->pl_acc;
	if (roll(100) > acc) {
	    i = roll(bombs) + 1;
	    if (i > bombs)
		i = bombs;
	    while (i--) {
		pr("BLAM");
		if (i)
		    pr("-");
		dam += (roll(16)+12)*2;
	    }
	    pr("\n");
	} else {
	    pr("thud\n");
	}
	plp->bombs = 0;
	if (dam <= 0) continue;
	if (dam > 100) dam = 100;
	own = plane.pln_own;
	if (dam > plane.pln_effic) {
	    plane.pln_effic = 0;
	    plane.pln_own = 0;
	} else
	    plane.pln_effic -= dam;
	plane.pln_mobil = (dam * plane.pln_mobil / 100.0);
	if (own == cnum) {
	    pr(fmt("%s %d reports %d%% damage\n",
		   plchr[plane.pln_type].pl_name, n, dam));
	} else {
	    wu(0, own,
	       fmt("%s pinpoint bombing raid did %d%% damage to %s #%d",
		   cname(cnum), dam, plchr[plane.pln_type].pl_name,
		   n));
	}
	nreport(cnum, N_DOWN_PLANE, plane.pln_own, 1);
	wu(0, own, fmt("%s bombs did %d%% damage to %s #%d at %s",
		       cname(cnum), dam, plchr[plane.pln_type].pl_name, n,
		       xyas(target->sct_x, target->sct_y, own)));
	putplane(n, &plane);
    next:
	;
    }
}

static nuke_bomb(list, target)
struct	qelem *list;
struct	sctstr *target;
{
    register struct plist *plp;
    struct	qelem *qp;
    
    for (qp = list->q_forw; qp != list; qp = qp->q_forw) {
	plp = (struct plist *) qp;
	if (plp->pcp->pl_flags & P_C)
	    continue;
	if (plp->plane.pln_nukeamt == 0)
	    continue;
	/*
	 * just drop one nuke per plane
	 * For now, only single-hex missions
	 * for nuclear fire missions
	 * its kinda silly to drop one nuke per plane,
	 * but...
	 * also, air bursts are only thing available
	 * from planes (to make them effectively
	 * second strike weapons)
	 */
	plp->plane.pln_nukeamt--;
	detonate(plp->plane.pln_nuketype, target->sct_x,
		 target->sct_y, 1, cnum);
    }
}

static strat_bomb(list, target)
struct	qelem *list;
struct	sctstr *target;
{
    register struct plist *plp;
    float eff,damage;
    int	dam,bombs,n,i;
    struct	qelem *qp;
    
    eff = 100.0;
    for (qp = list->q_forw; qp != list; qp = qp->q_forw) {
	plp = (struct plist *) qp;
	if (plp->pcp->pl_flags & P_C) continue;
	if (!plp->bombs) continue;
	bombs = plp->bombs;
	for (i=0; i<bombs; i++) {
	    if (i)
		pr("-");
	    n = roll(100);
	    if (n <= 10) {
		damage = 0.92;	/* 8% */
		pr("BLAM");
	    } else if (n < plp->pcp->pl_acc - 30) {
		damage = 0.95;	/* 5% */
		pr("Blam");
	    } else {
		damage = 0.98;	/* 2% */
		pr("blam");
	    }
	    eff *= damage;
	}
	pr("\n");
	plp->bombs = 0;
    }
    dam = (int) (100.0 - eff);
    pr(fmt("did %d%% damage in %s\n", dam,
	   xyas(target->sct_x, target->sct_y, cnum)));
    wu(0, target->sct_own, 
       fmt("%s bombing raid did %d%% damage in %s", cname(cnum), dam,
	   xyas(target->sct_x, target->sct_y, target->sct_own)));
    sectdamage(target, dam);
}
