#ifndef lint
static char *RCSid = "$Header: cens.c,v 1.1 89/12/14 08:19:25 jay Exp $";
#endif /* not lint */

/*
 * cens.c
 *
 * do a census report
 *
 * from PSL Empire, 1985
 */

#include "misc.h"
#include "var.h"
#include "xy.h"
#include "sect.h"
#include "nsc.h"
#include "nat.h"
#include "deity.h"
#include "path.h"
#include "file.h"

static	cens_hdr();

cens()
{
    extern char *argp[];
    struct sctstr sect;
    int	nsect,n;
    struct nstr_sect nstr;
    if (!snxtsct(&nstr, argp[1])) return RET_SYN;
    prdate();
    for (nsect=0; nxtsct(&nstr, &sect);) {
	if (!owner) continue;
	showcensus(&sect,(nsect++ == 0),0);
    }
    pr(fmt("    %d sector%s\n", nsect, splur(nsect)));
    return 0;
}

showcensus(sect,header,plusorminus)
struct sctstr *sect;
int header,plusorminus;
{
    char dirstr[20];
    int	vec[I_MAX+1];
    int n;
    for (n = 1; n <= 6; n++) dirstr[n] = dirch[n];
    dirstr[0] = '.';
    dirstr[7] = '$';
    dirstr[8] = '\0';
    if (header) {
	prest(plusorminus);
	cens_hdr();
    }
    if (god)
	pr(fmt("%3d ", sect->sct_own));
    pr(xyfmt("%4d,%-4d", sect->sct_x, sect->sct_y, cnum));
    pr(fmt(" %c", dchr[sect->sct_type].d_mnem));
    if (sect->sct_newtype != sect->sct_type)
	pr(fmt("%c", dchr[sect->sct_newtype].d_mnem));
    else
	pr(" ");
    pr(fmt("%4d%%", limestimate(sect->sct_effic,plusorminus,0,100)));
    pr(fmt("%4d", estimate(sect->sct_mobil,plusorminus)));
    
    getvec(VT_DEL, vec, (char *)sect, EF_SECTOR);
    pr(fmt(" %c", dirstr[vec[I_UW] & 0x7]));
    pr(fmt("%c", dirstr[vec[I_FOOD] & 0x7]));
    
    getvec(VT_DIST, vec, (char *)sect, EF_SECTOR);
    n = vec[I_UW] % 1000;
    pr(fmt(" %c", n == 0 ? '.' : '0'+ (n/100)));
    n = vec[I_FOOD] % 1000;
    pr(fmt("%c ", n == 0 ? '.' : '0'+ (n/100)));
    pr(fmt("%c", sect->sct_own != sect->sct_oldown ? '*' : ' '));
    
    getvec(VT_ITEM, vec, (char *)sect, EF_SECTOR);
    pr(fmt("%5d",   estimate(vec[I_CIVIL],plusorminus)));
    pr(fmt("%5d",   estimate(vec[I_MILIT],plusorminus)));
    pr(fmt("%5d",   estimate(vec[I_UW],plusorminus)));
    pr(fmt("%5d",   estimate(vec[I_FOOD],plusorminus)));
    pr(fmt("%4d%%", estimate(sect->sct_work,plusorminus)));
    pr(fmt("%5d",   estimate(sect->sct_avail,plusorminus)));
    pr(fmt("%7d",   estimate(sect->sct_harden,plusorminus)));
    if (!god && sect->sct_terr > 0)
	pr(fmt("%4d", sect->sct_terr));
    pr("\n");
}

static cens_hdr()
{
    if (god) pr("    ");
    pr("CENSUS               del dst\n");
    if (god) pr("own ");
    pr("  sect        eff mob uf uf *  civ  mil   uw food ");
    pr("work avail bunker ");
    if (!god)
	pr("ter");
    pr("\n");
}
