#ifndef lint
static char *RCSid = "$Header: fly.c,v 1.1 89/12/14 08:19:52 jay Exp $";
#endif

/*
 * fly.c
 *
 * uses plane units rather than plane "commodities"
 *
 * Dave Pare, 1986
 */

#include "misc.h"
#include "var.h"
#include "sect.h"
#include "ship.h"
#include "item.h"
#include "plane.h"
#include "nuke.h"
#include "xy.h"
#include "nsc.h"
#include "news.h"
#include "file.h"
#include "nat.h"
#include "path.h"

kfly() { flyplane(1); }
fly()  { flyplane(0); }

flyplane(kamikaze)
int kamikaze;
{
	extern	char *argp[];
	int	mission_flags,ap_to_target,cno,wantflags, dst_type;
	coord	tx,ty,  ax,ay,  x,y;
	struct	ichrstr *ip;
	struct	shpstr ship;
	struct	nstr_item ni_bomb,ni_esc;
	struct	qelem bomb_list,esc_list;
	struct	sctstr target,ap_sect;
	char	flightpath[256],*dst_ptr,*p;

	wantflags = 0;

	if (!snxtitem(&ni_bomb, EF_PLANE, argp[1]))    return RET_SYN;
	if (!snxtitem(&ni_esc, EF_PLANE, argp[2]))     pr("No escorts...\n");
	if (!getassemblypoint(argp[1],argp[3],&x,&y))  return RET_SYN;
	if (!getsect(x, y, &ap_sect))	               return RET_SYN;

#ifndef ASSEMBLEANYWHERE
	if (ap_sect.sct_own && ap_sect.sct_own!=cnum) {
	    pr("Assembly point not owned by you!\n");
	    return RET_SYN;
	}
#endif

	p = getpath(argp[4], ax=x, ay=y, 0, 0, 0);
	if (!p || !*p) return RET_SYN;
	(void)strcpy(flightpath, p);
	tx = ax;
	ty = ay;
	(void) pathtoxy(flightpath, &tx, &ty, fcost);
	pr(fmt("Ending sector is %s\n", xyas(tx, ty, cnum)));
	getsect(tx, ty, &target);
	cno = -1;
	ip = whatitem(argp[5], "transport what? ");
	dpr(fmt("ip = %d",ip));
	if (pln_onewaymission(&target, &cno, &wantflags) < 0)
		return RET_SYN;
	if (cno < 0) {
		dst_ptr = (char *) &target;
		dst_type = EF_SECTOR;
	} else {
		getship(cno, &ship);
		dst_ptr = (char *) &ship;
		dst_type = EF_SHIP;
	}
	ap_to_target = strlen(flightpath);
	pr(fmt("range to target is %d\n", ap_to_target));
	/*
	 * select planes within range
	 */
	pln_sel(&ni_bomb, &bomb_list, &ap_sect, ap_to_target,
		1, wantflags,     P_M|P_O, kamikaze ? "*" : "");
	pln_sel(&ni_esc, &esc_list, &ap_sect, ap_to_target,
		1, P_F|wantflags, P_M|P_O, "");
	/*
	 * now arm and equip the bombers, transports, whatever.
	 * tech is stored in high 16 bits of mission_flags.
	 * yuck.
	 */
	mission_flags = 0x7fff0000;
	mission_flags |= P_X;		/* stealth (shhh) */
	mission_flags = pln_arm(&bomb_list, 't', ip, 0, mission_flags);
	if (QEMPTY(&bomb_list)) {
		pr("No planes could be equipped for the mission.\n");
		return RET_FAIL;
	}
	mission_flags = pln_arm(&esc_list, 't', ip, P_F, mission_flags);
	ac_encounter(&bomb_list, &esc_list, ax, ay, flightpath, mission_flags);
	if (QEMPTY(&bomb_list)) {
		pr(fmt("No planes got through fighter defenses\n"));
	} else {
		getsect(tx, ty, &target);
		pln_dropoff(&bomb_list, ip, tx, ty, dst_ptr, dst_type);
		pln_newlanding(&bomb_list, tx, ty, cno);
		pln_newlanding(&esc_list, tx, ty, cno);
	}
	pln_put(&bomb_list);
	pln_put(&esc_list);
	return RET_OK;
}
