#ifndef lint
static char *RCSid = "$Header: leve.c,v 1.1 89/12/14 08:20:05 jay Exp $";
#endif /* not lint */

/*
 * leve.c
 *
 * do a distribution threshold level report
 *
 * David Muir Sharnoff, 1987
 */

#include "misc.h"
#include "var.h"
#include "sect.h"
#include "xy.h"
#include "nsc.h"
#include "nat.h"
#include "deity.h"
#include "file.h"
#include "path.h"

leve()
{
	extern	char *argp[];
	struct	sctstr sect;
	int	nsect,people;
	struct	nstr_sect nstr;

	if (!snxtsct(&nstr, argp[1]))
		return RET_SYN;
#ifdef DISTRIBUTEPEOPLE
	people = argp[2] && (*argp[2]=='p');
#else
	people = 0;
#endif
	prdate();
	nsect = 0;
	while (nxtsct(&nstr, &sect)) {
	    if (!owner) continue;
	    showlevels(&sect,people,(nsect++ == 0),0);
	}
	pr(fmt("    %d sector%s\n", nsect, splur(nsect)));
	return 0;
}

showlevels(sect,people,header,plusorminus)
struct sctstr *sect;
int people,header,plusorminus;
{
    int	dist[I_MAX+1];
    coord dstx,dsty;
    char *path;

    if (god) plusorminus = 0;

    if (header) {
	prest(plusorminus);
	pr("DISTRIBUTION LEVELS\n");
	if (god) pr(fmt("own"));
	pr("  sect    path------   dst    ");
	if (people)
	    pr("civ  mil   uw\n");
	else {
	    pr("uw food  sh gun pet iron dust bar ");
	    pr("oil lcm hcm rad\n");
	}
    }
    path = masktopath(sect->sct_distpath);
    dstx = sect->sct_x;
    dsty = sect->sct_y;
    (void) pathtoxy(path, &dstx, &dsty, mcost);
    if (god)
	pr(fmt("%2d ", sect->sct_own));
    getvec(VT_DIST, dist, (char *)sect, EF_SECTOR);
    pr(xyfmt("%3d,%-3d", sect->sct_x, sect->sct_y, cnum));
    pr(fmt(" %c ", dchr[sect->sct_type].d_mnem));
    pr(fmt("%10s ", *path ? path : ""));
    pr(xyfmt("%3d,%-3d", dstx, dsty, cnum));
    if (people) {
	pr(fmt("%5d", estimate(dist[I_CIVIL],plusorminus)));
	pr(fmt("%5d", estimate(dist[I_MILIT],plusorminus)));
	pr(fmt("%5d", estimate(dist[I_UW],plusorminus)));
    } else {
	pr(fmt("%4d", estimate(dist[I_UW],plusorminus)));
	pr(fmt("%5d", estimate(dist[I_FOOD],plusorminus)));
	pr(fmt("%4d", estimate(dist[I_SHELL],plusorminus)));
	pr(fmt("%4d", estimate(dist[I_GUN],plusorminus)));
	pr(fmt("%4d", estimate(dist[I_PETROL],plusorminus)));
	pr(fmt("%5d", estimate(dist[I_IRON],plusorminus)));
	pr(fmt("%5d", estimate(dist[I_DUST],plusorminus)));
	pr(fmt("%4d", estimate(dist[I_BAR],plusorminus)));
	pr(fmt("%4d", estimate(dist[I_OIL],plusorminus)));
	pr(fmt("%4d", estimate(dist[I_LCM],plusorminus)));
	pr(fmt("%4d", estimate(dist[I_HCM],plusorminus)));
	pr(fmt("%4d", estimate(dist[I_RAD],plusorminus)));
    }
    pr("\n");
}
