#ifndef lint
static char *RCSid = "$Header: look.c,v 1.1 89/12/14 08:20:07 jay Exp $";
#endif /* not lint */

/*
 * look.c
 *
 * lookout from a ship
 *
 * from PSL Empire, 1985
 */

#include "misc.h"
#include "var.h"
#include "xy.h"
#include "sect.h"
#include "deity.h"
#include "ship.h"
#include "nsc.h"
#include "nat.h"
#include "path.h"
#include "file.h"
#include "loc.h"
#include <fcntl.h>

#define ESDETECT	150	/* tech req'd to detect surveillance */
#define ESLOCATE	200	/* tech req'd to locate surveillance source */

static	look_ship();

look()
{
    extern char *argp[];
    register int i;
    struct nstr_item ni;
    struct natstr *natp;
    struct shpstr myship;
    struct sctstr sect;
    int	vec[I_MAX+1];
    int n, x, y;
    int spyship, tlev;
    u_char bitmap[WORLD_X*WORLD_Y/8];
    
    if (!snxtitem(&ni, EF_SHIP, argp[1])) 
	return RET_SYN;
    
    n = ef_close(EF_SHIP);
    dpr(fmt("initial ef_close returned %d",n));    
    if (!ef_open(EF_SHIP, O_RDONLY, EFF_MEM)) {
	pr("Cannot open ship file (EFF_MEM).\n");
	return RET_SYS;
    }
    dpr("initial ef_open okay");
    
    bzero((char *)bitmap, sizeof (bitmap));
    dpr("bitmap zeroed");
    while (nxtitem(&ni, (char *)&myship)) {
	if (!owner) continue;
	if (issub(&myship) && myship.shp_depth>1) continue;
	if (isballoon(&myship) && myship.shp_depth<1) continue;

	getvec(VT_ITEM, vec, (char *)&myship, EF_SHIP);
	if (vec[I_MILIT]+vec[I_CIVIL] == 0) continue; /* no crew */

	if (god) pr(fmt("*** %s %s #%d @ %s ***\n",cname(myship.shp_own),
			mchr[myship.shp_type].m_name,myship.shp_uid,
			xyas(myship.shp_x,myship.shp_y,cnum)));

	look_ship(&myship);
	look_plane(&myship);
	for (i = 0; i <= 6; i++) {
	    x = diroff[i][0] + myship.shp_x;
	    y = diroff[i][1] + myship.shp_y;
	    if (getbit(x, y, bitmap)) continue;
	    setbit(x, y, bitmap);
	    getsect(x, y, &sect);

	    if (sect.sct_type == SCT_WATER) continue;

	    if (sect.sct_own == cnum) pr("Your ");
	    else pr(fmt("%s (#%d) ",cname(sect.sct_own),sect.sct_own));

	    pr(dchr[sect.sct_type].d_name);
	    setbigmap(x, y, dchr[sect.sct_type].d_mnem);

	    if (mchr[myship.shp_type].m_flags & M_SPY) {

		if (!owner) switch (sect.sct_type) {
		case SCT_CAPIT:
		    natp = getnatp(sect.sct_own);
		    tlev = (int) natp->nat_level[NAT_TLEV];
		    if (!god && (tlev >= ESLOCATE))
			wu(0, sect.sct_own,
			   fmt("Electronic surveillance from %s detected in %s @ %s\n",
			       xyas(myship.shp_x,myship.shp_y,sect.sct_own),
			       dchr[sect.sct_type].d_name,
			       xyas(sect.sct_x,sect.sct_y,sect.sct_own)));
		    else if (!god && (tlev >= ESDETECT))
			wu(0, sect.sct_own,
			   fmt("Electronic surveillance detected in %s @ %s\n",
			       dchr[sect.sct_type].d_name,
			       xyas(sect.sct_x,sect.sct_y,sect.sct_own)));
		    break;
		}
		    
		pr(fmt(" approx %d%% eff ",owner ? sect.sct_effic :
		       round((int)sect.sct_effic, 10)));
		if (n=getvar(V_CIVIL,(char *)&sect,EF_SECTOR))
		    pr(fmt("%d civ ",owner ? n : round(n,10)));
		if (n=getvar(V_MILIT,(char *)&sect,EF_SECTOR))
		    pr(fmt("%d mil ",owner ? n : round(n,10)));
		if (n=getvar(V_FOOD,(char *)&sect,EF_SECTOR))
		    pr(fmt("%d food ",owner ? n : round(n,10)));
		if (n=getvar(V_GUN,(char *)&sect,EF_SECTOR))
		    pr(fmt("%d guns ",owner ? n : round(n,10)));
		if (n=getvar(V_SHELL,(char *)&sect,EF_SECTOR))
		    pr(fmt("%d she ",owner ? n : round(n,10)));
		if (n=getvar(V_PETROL,(char *)&sect,EF_SECTOR))
		    pr(fmt("%d pet ",owner ? n : round(n,10)));
	    } else {
		pr(fmt(" %d%% efficient ", owner ? sect.sct_effic :
		       round((int)sect.sct_effic, 10)));
		if (n=getvar(V_CIVIL, (char *)&sect, EF_SECTOR))
		    pr(fmt("with %s%d civ ", owner ? "" : "approx ",
			   owner ? n : round(n,10)));
		if (n=getvar(V_MILIT, (char *)&sect, EF_SECTOR))
		    pr(fmt("with %s%d mil ", owner ? "" : "approx ",
			   owner ? n : round(n, 10)));
	    }
	    pr(fmt("@ %s\n", xyas(x, y, cnum)));
	}
	writebigmap();
    }
    dpr("look done");
    n= ef_close(EF_SHIP);
    dpr(fmt("final ef_close returned %d",n));    
    if (!ef_open(EF_SHIP, O_RDWR, 0)) {
	pr("Cannot open ship file (normal)\n");
	return RET_SYS;
    }
    dpr("final ef_open okay");
    return RET_OK;
}

static look_plane(lookship)
register struct shipstr *lookship;
{
    /* report any aircraft in the vicinity */
}

static look_ship(lookship)
register struct shpstr *lookship;
{
    register struct shpstr *sp;
    register struct mchrstr *smcp;
    register struct mchrstr *tmcp;
    int	range;
    int	vrange;
    int	i;
    int	dist;
    int	vec[I_MAX+1];
    double factor, tvis;
    
    range = (int) techfact(lookship->shp_tech,
			   (double) mchr[lookship->shp_type].m_vrnge);
    range *= (lookship->shp_effic / 100.0);

    smcp = &mchr[lookship->shp_type];

    if (issub(lookship)) range = min(range, 1);

    for (i=0; sp = getshipp(i); i++) {
	if (sp->shp_uid == lookship->shp_uid ||
	    sp->shp_own == cnum ||
	    sp->shp_own == 0 ||
	    sp->shp_aboard >= 0)
	    continue;

	if (issub(sp) && sp->shp_depth>1) continue;

	if (issub(lookship))
	    factor = (lookship->shp_depth==0) ? 20.0 : 30.0;
	else if (isballoon(lookship))
	    factor = (lookship->shp_depth==0) ? 30.0 :
		((lookship->shp_depth==1) ? 20.0 : 10.0);
	else
	    factor = 20.0;

	tmcp = &mchr[sp->shp_type];
	tvis = (double) tmcp->m_visib;

	if (isballoon(sp)) tvis *= (sp->shp_depth+1);

	vrange = (int)( tvis * range / factor );
	dist = mapdist(sp->shp_x,sp->shp_y,lookship->shp_x,lookship->shp_y);
	if (dist > vrange) continue;

	/* Maybe notify target owner if being scanned by a submerged sub */
	if (!god && issub(lookship) && lookship->shp_depth>0) {
	    if (dist<2 && hassonar(sp)) {
		wu(0, sp->shp_own,
		   fmt("%s detected surfacing noises in %s.\n",
		       shipas(sp,0),
		       xyas(lookship->shp_x, lookship->shp_y,
			    sp->shp_own)));
	    }
	    if (dist==0 && !(isballoon(sp) && sp->shp_depth>0)) {
		wu(0, sp->shp_own,
		   fmt("Periscope spotted in %s by %s\n",
		       xyas(lookship->shp_x, lookship->shp_y,
			    sp->shp_own),shipas(sp,0)));
	    }
	}

	/*
	**  Submerged subs can be seen and identified only by sonar
	*/

	if (issub(sp)) switch (sp->shp_depth) {
	case 1: if (lookship->shp_depth==0 && chance(0.5))
	    pr(fmt("periscope @ %s\n", xyas(sp->shp_x, sp->shp_y, cnum)));
	case 2: continue;
	}

	/*
	**  Target is blatently visible
	*/

	if (dist > 0) 
	    pr(fmt("%s (#%d) %s #%d ",
		   cname(sp->shp_own),sp->shp_own,
		   (tmcp->m_flags & M_FOOD) ? "fishing vessel" : tmcp->m_name,
		   i));
	else
	    pr(fmt("%s ",shipas(sp,LO))); /* close enough to read names */
	
	/*
	**  Spy ships report a little more than usual about the target,
	**  but higher-tech targets with military aboard will detect
	**  that they are being scanned.
	*/

	if (smcp->m_flags & M_SPY) {
	    getvec(VT_ITEM, vec, (char *)sp, EF_SHIP);
	    pr(fmt("approx %d%% eff ",round(sp->shp_effic,10)));
	    pr(fmt("%d tech ",round(sp->shp_tech,10)));
	    if (!issub(sp)) {
		if (vec[I_CIVIL]) pr(fmt("%d civ ",round(vec[I_CIVIL],10)));
		if (vec[I_MILIT]) pr(fmt("%d mil ",round(vec[I_MILIT],10)));
		if (sp->shp_nplane) pr(fmt("%d plns ",round(sp->shp_nplane,2)));
		if (sp->shp_ntank) pr(fmt("%d tnks ",round(sp->shp_ntank,2)));
	    }
	    if (!god && vec[I_MILIT]) {
		if (sp->shp_tech >= ESLOCATE)
		    wu(0, sp->shp_own,
		       fmt("Electronic surveillance from %s detected by %s\n",
			   xyas(lookship->shp_x,lookship->shp_y,sp->shp_own),
			   shipas(sp,0)));
		else if (sp->shp_tech >= ESDETECT)
		    wu(0, sp->shp_own,
		       fmt("Electronic surveillance detected by %s\n",
			   shipas(sp,0)));
	    }
	}
	
	pr(fmt("@ %s\n", xyas(sp->shp_x, sp->shp_y, cnum)));
    }
}
