#ifndef lint
static char *RCSid = "$Header: lotto.c,v 1.0 91/06/14 15:00:00 bill Exp $";
#endif /* not lint */

/*
** lotto.c
**
** Give folks a chance to make some easy money
**
** 6/91 Bill Frolik
*/

#include <fcntl.h>
#include "gamesdef.h"
#include "misc.h"
#include "nat.h"
#include "file.h"
#include "deity.h"
#include "lotto.h"

lotto()
{
#ifdef LOTTERY
    extern char *argp[];
    struct natstr *natp;
    union lottorec lottery;
    int ball[LOTTOBALLS];
    int windfall[MAXNOC];
    int picks[NUMPICKS];
    int jackpot,secpot;
    int h,i,j,k,an,qp;
    char *p;
    tkt tick;

    natp = getnatp(cnum);

    /* ________________________________________________________________
    **|                                                                |
    **| syntax: "lotto r[eset]"                                        |
    **|________________________________________________________________|
    */

    if (god && argp[1] && *argp[1]=='r') {
	if (!locklotto(0,4)) return RET_FAIL;
	p = getstarg(argp[2],"Reset the lottery? ");
	if (p && (*p=='y')) resetlotto();
	unlocklotto();
	return RET_OK;
    }

    /* ________________________________________________________________
    **|                                                                |
    **| syntax: "lotto j[ackpot]"                                      |
    **|________________________________________________________________|
    */

    if (argp[1] && *argp[1]=='j') {
	if (!locklotto(0,4)) return RET_FAIL;
	if (openlotto()) {
	    readjackpot(&lottery.ticket);
	    closelotto();
	    pr(fmt("Grand jackpot is now $%d\n",lottery.jackpot.primary));
	    pr(fmt("Economic aid fund has $%d\n",lottery.jackpot.secondary));
	    if (god) {
		p = getstarg(argp[2],"New jackpot? ");
		if (p && (*p>='0' && *p<='9')) k = atoi(p); else k = -1;
		p = getstarg(argp[3],"New economic aid fund? ");
		if (p && (*p>='0' && *p<='9')) h = atoi(p); else h = -1;
		setjackpot(0,k,h);
	    }
	}
	unlocklotto();
	return RET_OK;
    }

    /* ________________________________________________________________
    **|                                                                |
    **| syntax: "lotto s[ales]"                                        |
    **|________________________________________________________________|
    */

    if (argp[1] && *argp[1]=='s') { /* sales report */
	if (!locklotto(0,4)) return RET_FAIL;
	if (openlotto()) {
	    readjackpot(&lottery.ticket);
	    pr(fmt("Grand prize is currently $%d\n",lottery.jackpot.primary));
	    pr(fmt("Economic aid fund has $%d\n",lottery.jackpot.secondary));
	    for (j=0; j<MAXNOC; j++) windfall[j]=0;
	    for (j=0; readticket(&lottery.ticket);)
		windfall[lottery.ticket.owner]++;
	    closelotto();
	    for (j=0; j<MAXNOC; j++)
		if (windfall[j]>0)
		    pr(fmt("%s has %d ticket(s)\n",cname(j),windfall[j]));
	}
	unlocklotto();
	return RET_OK;
    }

    /* ________________________________________________________________
    **|                                                                |
    **| syntax: "lotto l[ist]"                                         |
    **|________________________________________________________________|
    */

    if (argp[1] && *argp[1]=='l') {
	if (!locklotto(0,4)) return RET_FAIL;
	if (openlotto()) {
	    for (j=0; readticket(&lottery.ticket);) {
		if (god || (lottery.ticket.owner == cnum)) {
		    if (god) pr(fmt("%-12.12s (#%3d) ",
				    cname(lottery.ticket.owner),
				    lottery.ticket.owner));
		    for (i=0;i<NUMPICKS;i++)
			pr(fmt(" %3d",lottery.ticket.pick[i]));
		    pr("\n");
		    j++;
		}
	    }
	    closelotto();
	    if (j==0) pr("No tickets\n");
	    else pr(fmt("%d ticket%s\n",j,(j==1)?"":"s"));
	}
	unlocklotto();
	return RET_OK;
    }

    /* ________________________________________________________________
    **|                                                                |
    **| syntax: "lotto q[uickpick]"                                    |
    **|         "lotto [num] [num] [num]"                              |
    **|________________________________________________________________|
    */

    tick.cost = LOTTOTICKET;

    if (natp->nat_money < tick.cost) {
	pr("You can't afford a lottery ticket.\n");
	return RET_FAIL;
    }

    if (argp[1] && *argp[1]=='q') {
	qp = 1;
	an = 2;
    } else {
	qp = 0;
	for (i=0; i<NUMPICKS;) {
	    if ((p=getstarg(argp[i+1],
		    fmt("Pick #%d (1-%d)? ",i+1,LOTTOBALLS)))==0 || *p==0) {
		return RET_SYN;
	    }
	    argp[i+1] = "";
	    tick.pick[i] = atoi(p);
	    if (tick.pick[i]<=0 || tick.pick[i]>LOTTOBALLS)
		pr(fmt("%d: %d not in range 1-%d; try again.\n",
		       i+1,tick.pick[i],LOTTOBALLS));
	    else {
		for (j=0; j<i; j++) 
		    if (tick.pick[j]==tick.pick[i]) {
			pr(fmt("%d: %d already picked; try again.\n",
			       i,tick.pick[i]));
			break;
		    }
		if (i==j) i++;
	    }
	}
	an = NUMPICKS+1;
    }

    tick.owner = cnum;
    if (god) {
	i = natarg(argp[an],"Buy for which country? ");
	if (i < 0) return RET_SYN;
	tick.owner = i;
    }

    if (qp) quickpick(&tick);
    sortpicks(&tick);
    if (!locklotto(0,4)) return RET_FAIL;
    i = addticket(&tick);
    unlocklotto();

    if (!i)
	pr("Ticket rejected.\n");
    else {
	showpicks(&tick);
	dolcost += tick.cost;
	if (tick.owner != cnum) {
	    wu(0, tick.owner, 
	       fmt("%s bought you a lottery ticket",cname(cnum)));
	}
    }

#endif
    return RET_OK;
}


quickpick(tick)
tkt *tick;
{
    int h,i,j,k;
    int ball[LOTTOBALLS];
    for (i=0; i<LOTTOBALLS; i++) ball[i]=i+1;
    for (h=roll(LOTTOBALLS*2); h; h--) 
	for (i=0; i<LOTTOBALLS; i++) {
	    j = roll(LOTTOBALLS-1);
	    k=ball[i]; ball[i]=ball[j]; ball[j]=k;
	}
    for (i=0; i<NUMPICKS; i++)
	tick->pick[i] = ball[i];
}


showpicks(tick)
tkt *tick;
{
    int i;
    char *p,buf[30];
    for (p=buf,i=0; i<NUMPICKS; i++) {
	sprintf(p,"  %2d",tick->pick[i]);
	while (*p) p++;
    }
    pr(fmt("%s\n",buf));
}


sortpicks(tick)
tkt *tick;
{
    int i,j,k;
    for (i=0;i<NUMPICKS-1;i++)
	for (j=i+1;j<NUMPICKS;j++)
	    if (tick->pick[i] > tick->pick[j]) {
		k = tick->pick[i];
		tick->pick[i] = tick->pick[j];
		tick->pick[j] = k;
	    }
}

