#ifndef lint
static char *RCSid = "$Header: rea.c,v 1.1 89/12/14 08:20:35 jay Exp $";
#endif

/*
 * rea.c
 *
 * read from telegram file
 * modified to use stdio -- no sense in having
 * too many syscalls
 *
 * from PSL Empire, 1985
 */

#include "misc.h"
#include "nat.h"
#include "tel.h"
#include "deity.h"

#include <stdio.h>
#include <fcntl.h>
#include <sys/file.h>

rea()
{
    extern char *argp[];
    extern	char *telnames[];
    register char *p;
    register char *mbox;
    struct	telstr tgm;
    FILE   *telfp;
    int     teles;
    int     size;
    int     nbytes;
    char    buf[513];
    natid   num;
    int     lasttype;
    int     lastcnum;
    time_t  lastdate;
    int     header;
    int	n;
    int	filelen;
    
    if (god && argp[1] != 0) {
	if ((n = natarg(argp[1], "")) < 0)
	    return RET_SYN;
	num = n;
    } else
	num = cnum;
    mbox = mailbox(num);
    if ((telfp = fopen(mbox, "r+")) == 0) {
	logerror("telegram file %s", mbox);
	return RET_FAIL;
    }
    teles = 0;
    size = fsize(fileno(telfp));
 more:
    lastdate = 0;
    lastcnum = -1;
    lasttype = -1;
    while (fread((char *) &tgm, sizeof(tgm), 1, telfp) == 1) {
	if (tgm.tel_length < 0) {
	    logerror("bad telegram file header in %s", mbox);
	    break;
	}
	header = 0;
	if (tgm.tel_type != lasttype || tgm.tel_from != lastcnum)
	    header++;
	if (abs((int)(tgm.tel_date - (long)lastdate)) > 60)
	    header++;
	if (header) {
	    pr("> ");
	    lastcnum = tgm.tel_from;
	    lasttype = tgm.tel_type;
	    pr(fmt("%s ", telnames[tgm.tel_type]));
	    if ((tgm.tel_type == TEL_NORM) ||
		(tgm.tel_type == TEL_ANNOUNCE)) {
		pr(fmt("from %s, (#%d)",
		       cname(tgm.tel_from),
		       tgm.tel_from));
	    }
	    pr(fmt("  dated %s", ctime(&tgm.tel_date)));
	    lastdate = tgm.tel_date;
	}
	while (tgm.tel_length > 0) {
	    nbytes = tgm.tel_length;
	    if (nbytes > 512) nbytes = 512;
	    (void) fread(buf, sizeof(char), nbytes, telfp);
	    buf[nbytes] = 0;
	    prx(buf,tgm.tel_from);
	    tgm.tel_length -= nbytes;
	}
	pr("\n");
	teles++;
    }
    if (teles > 0 && cnum == num) {
	if (teles == 1) {
	    switch (roll(4)) {
	    case 1: p = "Forget this one? "; break;
	    default:p = "Shall I burn it? ";
	    }
	} else {
	    switch (roll(4)) {
	    case 1: p = "Into the shredder, boss? "; break;
	    default:p = "Can I throw away these old love letters? ";
	    }
	}
	p = getstring(p);
	if (p && *p == 'y') {
	    if (!file_lock(fileno(telfp))) {
		fclose(telfp);
		return RET_SYS;
	    }
	    if ((filelen = fsize(fileno(telfp))) > size) {
		pr("Wait a sec!  A new telegram has arrived...\n");
		/* force stdio to re-read tel file */
		(void) fseek(telfp, (long) size, L_SET);
		size = filelen;
		(void) file_unlock(fileno(telfp));
		goto more;
	    }
	    ftruncate(fileno(telfp), 0);
	    (void) file_unlock(fileno(telfp));
	}
    }
    if (teles <= 0)
	pr(fmt("No telegrams for %s at the moment...\n",
	       (cnum==num) ? "you" : cname(num)));
    (void) fclose(telfp);
    return RET_OK;
}

/*
**  Process 'buf' by first converting "{x,y}" substrings from
**  sender's coordinate system into cnum's coordinate system,
**  then passing the result on to pr().  This makes it possible 
**  for a sender to include in a telegram a position in his 
**  coordinate system (by enclosing it in curly braces), and 
**  have it read in the recipient's coordinate system.
**
**  6/91 bf@hp
*/

prx(buf,sender)
natid sender;
char *buf;
{
    char *s,*t,*u;
    char buf2[512];
    coord x,y;
    s = buf2;
    for (*s='\0'; *buf; buf++) {
	*s++ = *buf;
	t = buf;
	if (*t++ == '{') {
	    if (*t=='-' || isdigit(*t)) {
		x = atoip(&t);
		if (*t++ == ',') {
		    if (*t=='-' || isdigit(*t)) {
			y = atoip(&t);
			if (*t == '}') {
			    inputxy(&x,&y,sender);
			    u = xyas(x,y,cnum);
			    while (*u) *s++ = *u++;
			    buf = t-1;
			}
		    }
		}
	    }
	}
	*s = '\0';
	if (s-buf2 > 500) {
	    pr(buf2);
	    s = buf2;
	    *s = '\0';
	}
    }
    pr(buf2);
}
