#ifndef lint
static char *RCSid = "$Header: sate.c,v 1.1 89/12/14 08:20:45 jay Exp $";
#endif

/*
 * sate.c
 *
 * do satellite maps/reports
 *
 * Edward M. Rynes Esq, 1988
 */

#include "misc.h"
#include "var.h"
#include "xy.h"
#include "plane.h"
#include "sect.h"
#include "path.h"
#include "nsc.h"
#include "file.h"
#include "nat.h"
#include "deity.h"

char *viewspec(arg)
char *arg;
{
    char *spec;
    if ((spec=arg) && *arg) {
	while (*spec>' ') {
	    switch (*spec) {
	    case 's': case 't': case 'b': 
	    case 'p': case 'm': case 'l': break;
	    default: 
		pr(fmt("Option string '%s' contains bad option '%c'\n",
		       arg,*spec));
		pr("View option string must contain one or more of:\n");
		pr("  s - ships          m - map\n");
		pr("  t - tanks          l - land\n");
		pr("  b - balloons       p - planes\n");
		pr("  z - trains         r - resources\n");
		return((char *)0);
	    }
	    spec++;
	}
	return (arg);
    } else
	return ("slm");
}

sate()
{
    extern char *argp[];
    extern int etu_per_update;
    extern int plane_mob_max;
    extern int orbit_rate;
    double tech;
    struct nstr_item np;
    struct plnstr plane;
    char *spec;
    int i;
    
    if (!snxtitem(&np, EF_PLANE, argp[1])) return RET_SYN;
    if (!(spec = viewspec(argp[2]))) return RET_SYN;
    while (nxtitem(&np, (char *)&plane)) {
	if (!owner && !god) continue;
	if ((plane.pln_flags & PLN_LAUNCHED) && 
	    plane.pln_mobil == plane_mob_max){
	    if (plchr[plane.pln_type].pl_flags & P_S)
		pr("Satellite Spy Report:\n");
	    else
		pr("Satellite Map Report:\n");
	    pr(fmt("%s #%d ", plchr[plane.pln_type].pl_name,np.cur));
	    if (plane.pln_flags & PLN_ORBITDIR) {
		i = 1 + (plane.pln_flags & PLN_ORBITVEL)>>3;
		i = (i * etu_per_update) / orbit_rate;
		pr(fmt("(%d%c) ",i,
		       dirch[plane.pln_flags & PLN_ORBITDIR]));
	    } else
		pr("(sta) ");
	    pr("at ");
	    tech = techfact(plane.pln_tech, 20.0);
	    satmap2(plane.pln_x, plane.pln_y, plane.pln_effic,
		    (int)tech, plchr[plane.pln_type].pl_flags,spec);
	}
    }
    return RET_OK;
}

view()
{
    extern char *argp[];
    double tech;
    struct nstr_sect nstr;
    struct sctstr sect;
    char *spec;
    
    if (!snxtsct(&nstr, argp[1])) return RET_SYN;
    if (!(spec = viewspec(argp[2]))) return RET_SYN;
    if (nxtsct(&nstr,&sect)) {
	pr(fmt("POGO Satellite View @ %s:\n",
	       xyas(sect.sct_x,sect.sct_y,cnum)));
	tech = techfact(800.0, 20.0);
	satmap2(sect.sct_x,sect.sct_y,100,(int)tech,P_S|P_I,spec);
    }
    return RET_OK;
}


