#ifndef lint
static char *RCSid = "$Header: main.c,v 1.1 89/12/14 13:26:40 jay Exp $";
#endif /* not lint */

/*
 * main.c
 *
 * main command loop for Empire
 *
 * from PSL Empire, 1985
 */

#include "misc.h"
#include "proto.h"
#include "var.h"
#include "com.h"
#include "nat.h"
#include "sect.h"
#include "deity.h"
#include "file.h"
#include "proto.h"

#include <stdio.h>
#include <sys/time.h>

extern	int m_m_p_d;

char	combuf[512];
char	*argp[64];
char	*condarg;
time_t	lasttime;

char	*program = "player";
int	execmode;

extern	int pr();
int	(*leprfunc)() = pr;

natid	cnum;
int	nstat, ncomstat, minleft, btused;
int	god, broke;
int	owner;
time_t	curup;                   /* used in calc of minutes used */
double  dolcost;

main(argc, argv)
    int	argc;
    char	**argv;
{
    extern	int aborted;
    struct	natstr *natp;
    char	sobuf[4096];
    int	hour[2];
    int	clen;
    
    time(&lasttime);
    (void) time(&curup);
    (void) srandom(curup >> 16);
    setbuffer(stdout, sobuf, sizeof(sobuf));
    sigsetup();
    showvers(CLIENTPROTO);
    if (argc != 2) {
	pr("Empire problems!  Need country #\n");
	tm_exit(1);
    }
    cnum = atoi(argv[1]);
    if (cnum < 0 || cnum >= MAXNOC) {
	pr("Sorry, Empire problems.\n");
	tm_exit(2);
    }
    /*
     * get rid of the country number
     */
    clen = strlen(argv[1]);
    while (clen-- > 0)
	argv[1][clen] = ' ';
    if (!tm_connect()) {
	logerror("Can't connect to the transaction manager!");
	(void) fflush(stdout);
	tm_exit(0);
    }
    init_files();
    /* JNP 12/15/89   Open the bigmap file */
    openbigmap(cnum);
    init_nats();
    natp = getnatp(cnum);
    if (!gamehours(curup, hour)) {
	pr("Empire hours restriction in force\n");
	if ((natp->nat_stat & STAT_GOD) == 0) {
	    fflush(stdout);
	    tm_exit(0);
	}
    }
    getconstants();
    daychange(curup);
    if ((minleft = getminleft(curup, hour, &m_m_p_d)) <= 0) {
	pr("Time exceeded today\n");
	tm_exit(0);
    }
    NAT_DELTA(nat_login, cnum, 1);
    tm_sync(2000);
    while (status()) { /* while country is active */
	if (command() == 0 && !aborted) /* if eof(input), bail out */
	    break;
	aborted = 0;
    }
    quit();
    /*NOTREACHED*/
}

int command()
{
    char *redir;
    if (getcommand(combuf) < 0) return 0;
    if (parse(combuf, argp, &condarg, 0, &redir) < 0) {
	pr("See \"info syntax\"?\n");
    } else if (dispatch(combuf, redir) < 0)
	pr("Try \"list of commands\", \"info commands\" or \"info\"\n");
    return 1;
}

/*
 * empire main loop; plenty of system calls per iteration!
 * time(&curup), getsect(0,0), read(tm), read(gamedown),
 * read(stdin, cmdbuf).
 */
int status()
{
    extern	int locks;
    extern	int btused;
    struct	natstr *natp;
    int	minute;
    int	visitor;
    struct	sctstr sect;
    int	hour[2];
    
    natp = getnatp(cnum);
    visitor = (natp->nat_stat & (STAT_NORM|STAT_GOD)) == 0;
    if (dolcost != 0.0) {
	if (dolcost > 100.0)
	    pr(fmt("That just cost you $%.2f\n", dolcost));
	else if (dolcost < -100.0)
	    pr(fmt("You just made $%.2f\n", -dolcost));
	if (natp->nat_money < dolcost && !broke) {
	    broke = 1;
	    nstat &= ~MONEY;
	    pr("You are now broke; industries are on strike.\n");
	} else if (broke && natp->nat_money - dolcost > 0) {
	    broke = 0;
	    nstat |= MONEY;
	    pr(fmt("You are no longer broke!\n"));
	}
	NAT_DELTA(nat_money, cnum, -(int)(dolcost+0.5));
	dolcost = 0.0;
    }

    getsect(natp->nat_xcap, natp->nat_ycap, &sect);
    if ((sect.sct_type == SCT_CAPIT || sect.sct_type == SCT_SANCT) &&
	sect.sct_own == cnum)
	nstat |= CAP;
    else
	nstat &= ~CAP;

    ncomstat = nstat;
    (void) time(&curup);
    minute = (curup - lasttime) / 60;
    if (minute > 0) {
	minleft -= minute;
	if (minleft <= 0) {
	    /*
	     * countdown timer "minleft" has expired.
	     * either day change, or hours restriction
	     */
	    daychange(curup);
	    if (!gamehours(curup, hour)) {
		pr("Empire hours restriction in force\n");
		if ((natp->nat_stat & STAT_GOD) == 0)
		    return 0;
	    }
	    minleft = getminleft(curup, hour, &m_m_p_d);
	}
	lasttime += minute * 60;
	NAT_DELTA(nat_minused, cnum, minute);
    }
    if ((nstat & NORM) && natp->nat_minused > m_m_p_d) {
	pr("Max minutes per day limit exceeded.\n");
	ncomstat = VIS;
    }
    if (btused) {
	NAT_DELTA(nat_btu, cnum, -btused);
	btused = 0;
    }
    if (natp->nat_tgms > 0) {
	if (natp->nat_tgms == 1)
	    pr("You have a new telegram waiting ...\n");
	else
	    pr(fmt("You have %s new telegrams waiting ...\n",
		   numstr(natp->nat_tgms)));
	NAT_DELTA(nat_tgms, cnum, -natp->nat_tgms);
    }
    if (!visitor && !god && (nstat & CAP) == 0)
	pr("You lost your capital... better designate one\n");
    /*
     * either choice will flush buffer to tm, and then
     * get updated nat entries (among other things)
     */
    if (locks) {
	tm_unlock(locks);
	locks = 0;
    } else {
	tm_sync(450);
    }
    if (gamedown() && !god)
	return 0;
    return 1;
}

/*
**  Actually a command; redirection and piping ignored.
**  XXX This whole mess should be redone; execute block should
**  start with "exec start", and should end with "exec end".
**  We'll wait until 1.2 I guess.
*/

int execute()
{
    char *redir,buf[512];
    int	abort;
    abort = 0;
    redir = 0;
    prexec(argp[1]);
    while (!abort && status()) {
	if (recvclient(buf, sizeof(buf)) <= 0)
	    break;
	if (parse(buf, argp, &condarg, 0, &redir) < 0) {
	    abort = 1;
	    continue;
	}
	if (redir == 0)
	    pr(fmt("\nExecute : %s\n", buf));
	if (dispatch(buf, redir) < 0)
	    abort = 1;
    }
    if (redir == 0)
	pr(fmt("Execute : %s\n", abort ? "aborted" : "terminated"));
    return RET_OK;
}
