#ifndef lint
static char *RCSid = "$Header: satmap.c,v 1.1 89/12/14 13:28:35 jay Exp $";
#endif

/*
 * satmap.c
 *
 * do a satellite map given an x,y location, effic,
 * and other things.
 *
 * Author Unknown
 */

#include "misc.h"
#include "xy.h"
#include "sect.h"
#include "ship.h"
#include "plane.h"
#include "var.h"
#include "nsc.h"
#include "nat.h"
#include "file.h"

satmap(x, y, eff, range, flags)
int x,y,eff,range,flags;
{
    satmap2(x, y, eff, range, flags, "slm");
}

satmap2(x, y, eff, range, flags, spec)
int x,y,eff,range,flags;
char *spec;
{
    char rad[WORLD_Y][WORLD_X+1];
    struct sctstr sect;
    struct shpstr ship;
    struct plnstr plan;
    int count,row,n,rx,ry;
    struct nstr_item ni;
    struct nstr_sect ns;

    range *= (eff / 100.0);
    pr(fmt("%s efficiency %d%%, max range %d\n", xyas(x, y, cnum),
	   eff, range));
    snxtsct_dist(&ns, x, y, range);
    blankfill((char *)rad, &ns.range, 1);

    if (index(spec,'l')) 
	sathead("Satellite sector report\n",flags);

    for (count=0; nxtsct(&ns, &sect);) {
	if (index(spec,'l')) 
	    count += satdisp(&sect,0,flags);
	rad[ns.dy][ns.dx] = dchr[sect.sct_type].d_mnem;
	if (!(flags & P_I)) 
	    switch(sect.sct_type) {
	    case SCT_RURAL:
	    case SCT_WATER:
	    case SCT_WASTE:
	    case SCT_MOUNT: break;
	    default:
		if (sect.sct_own) rad[ns.dy][ns.dx] = '?';
	    }
	setbigmap(ns.x, ns.y, rad[ns.dy][ns.dx]);
    }
    writebigmap();

    if (index(spec,'l') && (flags & P_S))
	pr(fmt("  %d sectors\n\n", count));
	
	/*
	**  Show ships
	*/

	count = 0;
	if (index(spec,'s') && ((flags & P_S) || (flags & P_I))) {
	    snxtitem_dist(&ni, EF_SHIP, x, y, range);
	    if (flags & P_S) {
		pr("Satellite ship report\n");
		prdate();
		pr(" own  shp# ship type         sector   eff\n");
	    }
	    while (nxtitem(&ni, (caddr_t)&ship)) {
		if (ship.shp_own == 0)
		    continue;
		if (!isship(&ship)) continue;
		if ((mchr[ship.shp_type].m_flags & M_SUB) &&
		    ((flags & (P_S|P_I)) != (P_S|P_I)))
		    continue;
		if (ship.shp_aboard >= 0) continue;
		if (flags & P_S) {
		    pr(fmt("%4d %4d %-16.16s %s %3d%%\n",
			   ship.shp_own, ship.shp_uid,
			   mchr[ship.shp_type].m_name,
			   xyfmt("%4d,%-4d", ship.shp_x,
				 ship.shp_y, cnum), ship.shp_effic));
		    ++count;
		}
		if (flags & P_I) {
		    /* &~0x20 makes it a cap letter */
		    ry = deltay((int)ship.shp_y, (int)ni.range.ly);
		    rx = deltax((int)ship.shp_x, (int)ni.range.lx);
		    rad[ry][rx] =
			(*mchr[ship.shp_type].m_name) & ~0x20;
		}
	    }
	    if (flags & P_S)
		pr(fmt("  %d ships\n\n", count));
	}

#ifdef TANKS
	/*
	**  Show tanks
	*/

	count = 0;
	if (index(spec,'t') && ((flags & P_S) || (flags & P_I))) {
	    snxtitem_dist(&ni, EF_SHIP, x, y, range);
	    if (flags & P_S) {
		pr("Satellite tank report\n");
		prdate();
		pr(" own  tnk# tank type         sector   eff\n");
	    }
	    while (nxtitem(&ni, (caddr_t)&ship)) {
		if (ship.shp_own == 0) continue;
		if (!istank(&ship)) continue;
		if (ship.shp_aboard >= 0) continue;
		if (flags & P_S) {
		    pr(fmt("%4d %4d %-16.16s %s %3d%%\n",
			   ship.shp_own, ship.shp_uid,
			   mchr[ship.shp_type].m_name,
			   xyfmt("%4d,%-4d", ship.shp_x,
				 ship.shp_y, cnum), ship.shp_effic));
		    ++count;
		}
		if (flags & P_I) {
		    /* &~0x20 makes it a cap letter */
		    ry = deltay((int)ship.shp_y, (int)ni.range.ly);
		    rx = deltax((int)ship.shp_x, (int)ni.range.lx);
		    rad[ry][rx] =
			(*mchr[ship.shp_type].m_name) & ~0x20;
		}
	    }
	    if (flags & P_S)
		pr(fmt("  %d tanks\n\n", count));
	}
#endif

#ifdef TRAINS
	/*
	**  Show trains
	*/

	count = 0;
	if (index(spec,'z') && ((flags & P_S) || (flags & P_I))) {
	    snxtitem_dist(&ni, EF_SHIP, x, y, range);
	    if (flags & P_S) {
		pr("Satellite train report\n");
		prdate();
		pr(" own  trn# train type        sector   eff\n");
	    }
	    while (nxtitem(&ni, (caddr_t)&ship)) {
		if (ship.shp_own == 0) continue;
		if (!istrain(&ship)) continue;
		if (ship.shp_aboard >= 0) continue;
		if (flags & P_S) {
		    pr(fmt("%4d %4d %-16.16s %s %3d%%\n",
			   ship.shp_own, ship.shp_uid,
			   mchr[ship.shp_type].m_name,
			   xyfmt("%4d,%-4d", ship.shp_x,
				 ship.shp_y, cnum), ship.shp_effic));
		    ++count;
		}
		if (flags & P_I) {
		    /* &~0x20 makes it a cap letter */
		    ry = deltay((int)ship.shp_y, (int)ni.range.ly);
		    rx = deltax((int)ship.shp_x, (int)ni.range.lx);
		    rad[ry][rx] =
			(*mchr[ship.shp_type].m_name) & ~0x20;
		}
	    }
	    if (flags & P_S)
		pr(fmt("  %d trains\n\n", count));
	}
#endif

#ifdef PLANES
	/*
	**  Show planes
	*/

	count = 0;
	if (index(spec,'p') && ((flags & P_S) || (flags & P_I))) {
	    snxtitem_dist(&ni, EF_PLANE, x, y, range);
	    if (flags & P_S) {
		pr("Satellite plane report\n");
		prdate();
		pr(" own  pln# plane type        sector   eff\n");
	    }
	    while (nxtitem(&ni, (caddr_t)&plan)) {
		if ((plan.pln_flags & PLN_BOXED) || !plan.pln_own || (plan.pln_ship >= 0))
		    continue;
		if (flags & P_S) {
		    pr(fmt("%4d %4d %-16.16s %s %3d%%\n",
			   plan.pln_own, plan.pln_uid,
			   plchr[plan.pln_type].pl_name,
			   xyfmt("%4d,%-4d", plan.pln_x,plan.pln_y,cnum),
			   plan.pln_effic));
		    ++count;
		}
		if (flags & P_I) {
		    /* &~0x20 makes it a cap letter */
		    ry = deltay((int)plan.pln_y, (int)ni.range.ly);
		    rx = deltax((int)plan.pln_x, (int)ni.range.lx);
		    rad[ry][rx] =
			(*plchr[plan.pln_type].pl_name) & ~0x20;
		}
	    }
	    if (flags & P_S)
		pr(fmt("  %d planes\n\n", count));
	}
#endif

#ifdef BALLOONS
	/*
	**  Show balloons
	*/
	
	count = 0;
	if (index(spec,'b') && ((flags & P_S) || (flags & P_I))) {
	    snxtitem_dist(&ni, EF_SHIP, x, y, range);
	    if (flags & P_S) {
		pr("Satellite balloon report\n");
		prdate();
		pr(" own  bal# balloon type      sector   eff\n");
	    }
	    while (nxtitem(&ni, (caddr_t)&ship)) {
		if (ship.shp_own == 0)
		    continue;
		if (!isballoon(&ship)) continue;
		if (flags & P_S) {
		    pr(fmt("%4d %4d %-16.16s %s %3d%%\n",
			   ship.shp_own, ship.shp_uid,
			   mchr[ship.shp_type].m_name,
			   xyfmt("%4d,%-4d", ship.shp_x,
				 ship.shp_y, cnum), ship.shp_effic));
		    ++count;
		}
		if (flags & P_I) {
		    /* &~0x20 makes it a cap letter */
		    ry = deltay((int)ship.shp_y, (int)ni.range.ly);
		    rx = deltax((int)ship.shp_x, (int)ni.range.lx);
		    rad[ry][rx] =
			(*mchr[ship.shp_type].m_name) & ~0x20;
		}
	    }
	    if (flags & P_S)
		pr(fmt("  %d balloons\n\n", count));
	}
#endif

	/*
	 * print out the map
	 * We have to make the center a '0' for ve
	 * ve needs a garbage line to terminate the map
	 */
	rad[deltay(y, ns.range.ly)][deltax(x, ns.range.lx)] = '0';

	if (index(spec,'m')) {
	    pr("Satellite radar report\n");
	    n = deltay(ns.range.hy, ns.range.ly);
	    for (row=0; row < n; row++)
		pr(fmt("%s\n", rad[row]));
	    pr("\n(c) 1989 Imaginative Images Inc.\n");
	}
    }

sathead(title,flags)
char *title;
int flags;
{
    if (!(flags & (P_S|P_E))) 
	return;
    pr(title);
    prdate();
    if (flags & P_S) {
	pr("   sect type own eff civ  mil  shl  gun  iron pet  food");
	if (flags & P_E) pr(" hcm  lcm  oil  rad  bun");
    } else
	pr("   sect type min gld frt oil urn");
    pr("\n");
}

satdisp(sp, acc, flags)
struct sctstr *sp;
int acc,flags;
{
    int	vec[I_MAX+1];
    int spying,imaging,enhanced;
    spying = flags & P_S;
    imaging = flags & P_I;
    enhanced = flags & P_E;

    if (!(spying || enhanced)) return 0;

    if (getvec(VT_ITEM, vec, (caddr_t)sp, EF_SECTOR) < 0) return 0;

    if (acc==0) acc = imaging ? 5 : 50;
    if (enhanced) acc >>= 1;

    if (sp->sct_type < SCT_RURAL) return 0;
    
    if (sp->sct_type == SCT_RURAL) {
	if (!enhanced) return 0;
	if (spying && vec[I_CIVIL]==0 && vec[I_MILIT]==0) return 0;
    }

    if (spying) {
	pr(fmt("%s  %c %3d %3d %4d %4d %4d %4d %4d %4d %4d",
	       xyfmt("%4d,%-4d", sp->sct_x, sp->sct_y, cnum),
	       (imaging || sp->sct_type<SCT_RURAL) ? 
	           dchr[sp->sct_type].d_mnem : '?',
	       sp->sct_own, round((int)sp->sct_effic, acc / 2),
	       round(vec[I_CIVIL], acc), round(vec[I_MILIT], acc),
	       round(vec[I_SHELL], acc), round(vec[I_GUN], acc),
	       round(vec[I_IRON], acc), round(vec[I_PETROL], acc),
	       round(vec[I_FOOD], acc)));
	if (enhanced)
	    pr(fmt(" %4d %4d %4d %4d %3d",
		   round(vec[I_HCM], acc), round(vec[I_LCM], acc),
		   round(vec[I_OIL], acc), round(vec[I_RAD], acc),
		   round(sp->sct_harden, acc)));
	pr("\n");
	return 1;
    }

    if (enhanced) {
	pr(fmt("%s  %c %3d %3d %3d %3d %3d\n",
	       xyfmt("%4d,%-4d", sp->sct_x, sp->sct_y, cnum),
	       (imaging || sp->sct_type<SCT_RURAL) ? 
	           dchr[sp->sct_type].d_mnem : '?',
	       round(sp->sct_min,acc),
	       round(sp->sct_gmin,acc),
	       round(sp->sct_fertil,acc),
	       round(sp->sct_oil,acc),
	       round(sp->sct_uran,acc)));
	return 1;
    }

    return 0;
}
