#ifndef lint
static char *RCSid = "$Header: takeover.c,v 1.1 89/12/14 13:28:41 jay Exp $";
#endif

/*
 * takeover.c
 *
 * take over from another power.
 * set up loyalty to new govt, old owner.
 *
 * Dave Pare, 1986
 */

#include "misc.h"
#include "var.h"
#include "sect.h"
#include "xy.h"
#include "nsc.h"
#include "nat.h"
#include "plane.h"
#include "ship.h"
#include "file.h"
#include "nuke.h"
#include "loc.h"

extern int eduratio; /* education ratio needed to capture nukes */

int
takeover(sp, mil)
	register struct sctstr *sp;
	int	mil;
{
	int	civ;
	int	che;
	int	che_count;
	int	oldche;
	int	n;

	takeplanes(sp->sct_x,sp->sct_y,cnum,sp->sct_own==sp->sct_oldown);
	takeships(sp->sct_x,sp->sct_y,cnum);
	takenukes(sp->sct_x,sp->sct_y,cnum);

	sp->sct_avail = 0;
	civ = getvar(V_CIVIL, (char *)sp, EF_SECTOR);
	oldche = get_che_value(getvar(V_CHE, (char *)sp, EF_SECTOR));
	/*
	 * create guerrillas from civilians
	 * how spunky are these guys?
	 * n: random number from -50:50 + 50
	 */
	n = (50 - sp->sct_loyal) + (random() % 100) - 50;
	che_count = 0;
	che = 0;
	if (n > 0 && sp->sct_own == sp->sct_oldown) {
		che_count = (civ * n/3000) + 5;
		if (che_count * 2 > civ)
			che_count = civ / 2;
		if (che_count > 0) {
			civ -= che_count;
			che_count += oldche;
			set_che_value(che, che_count);
			set_che_cnum(che, cnum);
			(void) putvar(V_CHE, che, (char *)sp, EF_SECTOR);
		}
	}
	if (sp->sct_oldown == cnum || civ == 0) {
		/*
		 * taking over one of your old sectors
		 */
		sp->sct_loyal = 0;
		sp->sct_oldown = cnum;
	} else {
		/*
		 * taking over someone else's sector
		 */
		sp->sct_loyal = 50;
	}
	sp->sct_own = cnum;
	return mil;
}

takeplanes(x,y,c,retake)
int x,y,c,retake;
{
    register struct plnstr *pp;
    struct nstr_item ni;
    struct plnstr p;
    int n;
    /*
    **  Take over any planes in sector x,y
    */
    pp = &p;
    snxtitem_dist(&ni, EF_PLANE, x, y, 0);
    while (nxtitem(&ni, (caddr_t)pp)) {
	if ((pp->pln_own == c) || (pp->pln_own == 0)) continue;
	if (pp->pln_flags & PLN_LAUNCHED) continue;
	/*
	** XXX If this was done right, planes could escape,
	** flying to a nearby friendly airport.
	**
	** bf@hp - Added 'retake' flag and some randomness code
	** so that if the new owner is reconquering a sector
	** that he previously owned (he is still listed as the 
	** old owner), there is only a 20% chance that a plane
	** will be blown up.
	*/
	n = pp->pln_effic - (30+(random() % 100));
	pp->pln_effic = (n < 0) ? 0 : n;
	if ((retake && chance(0.20)) || 
	    (!retake && (pp->pln_effic < 10 || pp->pln_harden > 0))) {
	    pp->pln_effic = 0;
	    pr(fmt("%s #%d blown up by the crew!\n",
		   plchr[pp->pln_type].pl_name, ni.cur));
	}
	else {
	    pr(fmt("%s %s #%d captured in %s\n",
		   cname(pp->pln_own),plchr[pp->pln_type].pl_name,
		   pp->pln_uid,xyas(x,y,c)));
	    pp->pln_effic = 20;
	    wu(0, pp->pln_own,
	       fmt("%s #%d captured by %s in %s\n",
		   plchr[pp->pln_type].pl_name,pp->pln_uid,
		   cname(c),xyas(x,y,pp->pln_own)));
	    }
	if (pp->pln_mobil > 0) pp->pln_mobil = 0;
	pp->pln_own = c;
	putplane(ni.cur, pp);
    }
}

takeships(x,y,c)
int x,y,c;
{
    struct nstr_item nb;
    struct shpstr shp;
    int vec[I_MAX+1];
    /*
    **  7/2/90 bf@hp - take over any empty ships in sector x,y 
    */
    if (snxtitem(&nb, EF_SHIP,"*")) {
	while (nxtitem(&nb, (char *)&shp)) {
	    if (!shp.shp_own || shp.shp_own==c) continue;
	    if ((shp.shp_x != x) || (shp.shp_y != y)) continue;
	    if (shp.shp_depth > 0) continue;
	    getvec(VT_ITEM, vec, (char *)&shp, EF_SHIP);
	    if (vec[I_MILIT] != 0 || vec[I_CIVIL] != 0)	continue;
	    pr(fmt("%s %s #%d captured in %s\n",
		   cname(shp.shp_own),mchr[shp.shp_type].m_name,
		   shp.shp_uid,xyas(x,y,c)));
	    wu(0, shp.shp_own,
	       fmt("%s #%d captured by %s in %s\n",
		   mchr[shp.shp_type].m_name,shp.shp_uid,
		   cname(c),xyas(x,y,shp.shp_own)));
	    takeover_ship(&shp,c); /* acquire the ship */
	    putship(shp.shp_uid,&shp);   
	}
    }
}

takenukes(x,y,c)
int x,y,c;
{
    struct nstr_item nb;
    struct nukstr nuk;
    struct natstr *natp;
    float hisedu, ouredu;
    /*
    **  9/7/90 bf@hp - take over any nukes in sector x,y 
    **
    **  9/26/90 bf@hp - Info page says nukes are intentionally uncapturable.
    **			This doesn't seem entirely fair, so I added an
    **			education level check.  Now only a country that is
    **			much more educated than the old nuke owner is able
    **			to "crack the failsafe code" and capture the nuke.
    **			To make nukes uncapturable, set 'eduratio' negative.
    */
    natp = getnatp(c);
    ouredu = natp->nat_level[NAT_ELEV];
    if (snxtitem(&nb, EF_NUKE,"*")) {
	while (nxtitem(&nb, (char *)&nuk)) {
	    if (!nuk.nuk_own || nuk.nuk_own==c) continue;
	    if ((nuk.nuk_x != x) || (nuk.nuk_y != y)) continue;
	    if (eduratio < 0) continue;
	    natp = getnatp(nuk.nuk_own);
	    hisedu = natp->nat_level[NAT_ELEV];
	    if (ouredu < (eduratio*hisedu)) continue;
	    pr(fmt("%s nuclear device #%d captured in %s\n",
		   cname(nuk.nuk_own),nuk.nuk_uid,xyas(x,y,c)));
	    wu(0, nuk.nuk_own,
	       fmt("nuclear device #%d captured by %s in %s\n",
		   nuk.nuk_uid,cname(c),xyas(x,y,nuk.nuk_own)));
	    nuk.nuk_own = c; /* acquire the nuke */
	    putnuke(nuk.nuk_uid,&nuk);   
	}
    }
}

takeover_ship(sp, newown)
register struct shpstr *sp;
natid	newown;
{
    register struct plnstr *pp;
    register struct nukstr *np;
    struct	mchrstr *mp;
    struct	nstr_item ni;
    struct	plnstr p;
    struct  nukstr n;
    
    mp = &mchr[sp->shp_type];
    sp->shp_own = newown;
    if (sp->shp_autonav & AN_AUTONAV) {
	if (newown==cnum)
	    pr(fmt("%s #%d orders to %s cancelled\n",
		   mp->m_name,sp->shp_uid,
		   xyas(sp->shp_destx,sp->shp_destx,cnum)));
    }
    sp->shp_autonav = 0;
    
    /* NOTE: you do NOT acquire tanks aboard the ship */
    
    if ((mp->m_flags & (M_FLY|M_MSL|M_HELI|M_VTOL|M_TAC)) == 0) return;
    
    /* Acquire all planes aboard the ship */
    
    pp = &p;
    snxtitem_all(&ni, EF_PLANE);
    while (nxtitem(&ni, (caddr_t)pp)) {
	if (pp->pln_ship != sp->shp_uid) continue;
	if (pp->pln_effic > 10) pp->pln_effic = 10;
	if (pp->pln_mobil > 0)	pp->pln_mobil = 0;
	pp->pln_own = newown;
	putplane(ni.cur, pp);
    }
    
    /* Acquire all nukes aboard the ship */
    
    np = &n;
    snxtitem_all(&ni, EF_NUKE);
    while (nxtitem(&ni, (caddr_t)np)) {
	if (np->nuk_ship != sp->shp_uid) continue;
	np->nuk_own = newown;
	putnuke(ni.cur, pp);
    }
}

