#ifndef lint
static char *RCSid = "$Header: trdsub.c,v 1.1 89/12/14 13:28:42 jay Exp $";
#endif /* not lint */

/*
 * trdsub.c
 *
 * trade helper routines
 *
 * St Phil, 1989
 */

#include "misc.h"
#include "var.h"
#include "sect.h"
#include "nat.h"
#include "item.h"
#include "ship.h"
#include "nuke.h"
#include "plane.h"
#include "trade.h"
#include "xy.h"
#include "nsc.h"
#include "file.h"


char *
trade_nameof(tp, tgp)
	struct	trdstr *tp;
	union	trdgenstr *tgp;
{
	switch (tp->trd_type) {
	case EF_NUKE:
		return "nuclear stockpile";
	case EF_PLANE:
		return plchr[tgp->pln.pln_type].pl_name;
	case EF_SHIP:
		return mchr[tgp->shp.shp_type].m_name;
	}
	return "Bad trade type, get help";
}

/*
 * Describe an item up for sale.  "tgp" is a union containing
 * the details of the generic item.
 * Return 1 on success, 0 on error
 */
trade_desc(tp, tgp)
struct trdstr *tp;
union trdgenstr *tgp;
{
    int	i;
    float	price;
    struct	sctstr sect;
    struct	nukstr *np;
    struct	shpstr *sp;
    struct	plnstr *pp;
    struct	natstr *natp;
    int	needcomma;
    
    price = multread(tp->trd_owner, cnum) * tp->trd_price;
    switch (tp->trd_type) {
    case EF_NUKE:
	np = &tgp->nuk;
	if (!getsect(np->nuk_x, np->nuk_y, &sect))
	    return 0;
	tp->trd_owner = sect.sct_own;
	natp = getnatp(tp->trd_owner);
#ifndef TELEPORTPLANES
	pr(fmt("%8.8s  %10.2f ",natp->nat_cnam,price));
	pr(xyfmt("%4d,%-4d  ",np->nuk_x,np->nuk_y,cnum));
	pr(fmt("%c  ",dchr[sect.sct_type].d_mnem));
#else
	pr(fmt("(#%3d)  %8.8s  %10.2f ",
	       sect.sct_own,natp->nat_cnam,price));
#endif
	needcomma = 0;
	for (i = 0; i < N_MAXNUKE; i++) {
	    if (np->nuk_types[i]) {
		if (needcomma)
		    pr(",");
		pr(fmt("%dx%s", np->nuk_types[i],
		       nchr[i].n_name));
		needcomma = 1;
	    }
	}
	break;
    case EF_SHIP:
	sp = &tgp->shp;
	if (!getsect(sp->shp_x,sp->shp_y,&sect)) return 0;
	tp->trd_owner = sp->shp_own;
#ifndef TELEPORTPLANES
	pr(fmt("%8.8s  %10.2f ",cname(tp->trd_owner),price));
	pr(xyfmt("%4d,%-4d  ",sp->shp_x,sp->shp_y,cnum));
	pr(fmt("%c  ",dchr[sect.sct_type].d_mnem));
#else
	pr(fmt("(#%3d)  %8.8s  %10.2f ",
	       tp->trd_owner, cname(tp->trd_owner),
	       price));
#endif
	pr(fmt("tech %d %d%% %s [",
	       sp->shp_tech,
	       sp->shp_effic,
	       mchr[sp->shp_type].m_name));
	for (i = 0; i < sp->shp_nv; i++) {
	    pr(fmt("%c:%d ",
		   ichr[sp->shp_vtype[i] & ~VT_TYPE].i_mnem,
		   sp->shp_vamt[i]));
	}
	pr(fmt("] #%d", tp->trd_unitid));
	break;
    case EF_PLANE:
	pp = &tgp->pln;
	if (!getsect(pp->pln_x,pp->pln_y,&sect)) return 0;
	tp->trd_owner = pp->pln_own;
#ifndef TELEPORTPLANES
	pr(fmt("%8.8s  %10.2f ", cname(tp->trd_owner), price));
	pr(xyfmt("%4d,%-4d  ", pp->pln_x,pp->pln_y,cnum));
	pr(fmt("%c  ", dchr[sect.sct_type].d_mnem));
#else
	pr(fmt("(#%3d)  %8.8s  %10.2f ",
	       tp->trd_owner, 
	       cname(tp->trd_owner),
	       price));
#endif
	pr(fmt("tech %d %d%% %s%s #%d",
	       pp->pln_tech,
	       pp->pln_effic,
	       pp->pln_flags & PLN_BOXED ? "crated " : "",
	       plchr[pp->pln_type].pl_name,
	       tp->trd_unitid));
	if (pp->pln_nuketype && pp->pln_nukeamt)
	    pr(fmt("(%dx%s)", 
		   pp->pln_nukeamt,
		   nchr[pp->pln_nuketype].n_name));
	break;
    default:
	pr(fmt("flaky unit type %d", tp->trd_type));
	break;
    }
    return 1;
}

int
trade_getitem(tp, tgp)
	struct	trdstr *tp;
	union	trdgenstr *tgp;
{
	if (!ef_nbread(tp->trd_type, tp->trd_unitid, (char *)tgp))
		return 0;
	return 1;
}
