#ifndef lint
static char *RCSid = "$Header: mobility.c,v 1.1 89/12/14 13:30:46 jay Exp $";
#endif

/*
 * mobility.c
 *
 * Add mobility to each of the items which accumlate mobility.
 * 
 * Dave Pare, 1986
 */

#include "misc.h"
#include "var.h"
#include "sect.h"
#include "ship.h"
#include "plane.h"
#include "spy.h"
#include "nat.h"
#include "file.h"
#include "tm.h"

mob_sect(etus)
	register int etus;
{
	extern	int sect_mob_scale;
	extern	int sect_mob_max;
	extern	double revert_water_odds;
	register struct sctstr *sp;
	register int value;
	register int n;

	for (n=0; sp = getsectid(n); n++) {
	    if (sp->sct_type == SCT_WASTE && sp->sct_mobil<255) {
		if (sp->sct_mobil > 0) 
		    sp->sct_mobil--;
		else {
		    sp->sct_type = chance(revert_water_odds) ? SCT_WATER : SCT_RURAL;
		    sp->sct_newtype = sp->sct_type;
		    sp->sct_own = 0;
		    sp->sct_oldown = 0;
		    sp->sct_effic = 0;
		    sp->sct_mobil = 0;
		    sp->sct_nv = 0;
		    sp->sct_terr = 0;
		    sp->sct_avail = 0;
		    sp->sct_loyal = 127;
		    sp->sct_fertil = roll(100)-1;
		    sp->sct_min = roll(100)-1;
		    sp->sct_gmin = roll(100)-1;
		    sp->sct_oil = roll(100)-1;
		    sp->sct_uran = roll(100)-1;
		    }
		continue;
	    }
	    if (sp->sct_own == 0) continue;
	    value = sp->sct_mobil + etus * sect_mob_scale;
	    if (value > sect_mob_max)
		value = sect_mob_max;
	    sp->sct_mobil = value;
	}
}

mob_ship(etus)
	register int etus;
{
	extern	int ship_mob_max;
	extern	int ship_mob_scale;
	register struct shpstr *sp;
	register int value;
	register int n;

	for (n=0; sp = getshipp(n); n++) {
		if (sp->shp_own == 0)
			continue;
		value = sp->shp_mobil + etus * ship_mob_scale;
		if (value > ship_mob_max)
			value = ship_mob_max;
		sp->shp_mobil = value;
	}
}

mob_plane(etus)
	register int etus;
{
#ifdef PLANES
	extern	int plane_mob_max;
	extern	int plane_mob_scale;
	register struct plnstr *pp;
	register int value;
	register int n;

	for (n=0; pp = getplanep(n); n++) {
		if (pp->pln_own == 0)
			continue;
		value = pp->pln_mobil + etus * plane_mob_scale;
		if (value > plane_mob_max)
			value = plane_mob_max;
		pp->pln_mobil = value;
	}
#endif
}

mob_spy(etus)
register int etus;
{
#ifdef SPIES
    extern int spy_mob_max;
    extern int spy_mob_scale;
    register struct spystr *spyp;
    register int value;
    register int n;
    
    for (n=0; spyp = getspyp(n); n++) {
	if (spyp->spy_own == 0) continue;
	value = spyp->spy_mobil + etus * spy_mob_scale;
	if (value > spy_mob_max)
	    value = spy_mob_max;
	spyp->spy_mobil = value;
    }
#endif
}
