/*
**  spy.c
**
**  Do "production" for spies -- make more efficient, etc.
**
**  Bill Frolik, 1991
*/

#include "misc.h"
#include "var.h"
#include "sect.h"
#include "ship.h"
#include "spy.h"
#include "nat.h"
#include "file.h"
#include "plane.h"

#define natHLEV 	(nat->nat_level[NAT_HLEV])
#define natELEV 	(nat->nat_level[NAT_ELEV])
#define natTLEV 	(nat->nat_level[NAT_TLEV])

int prod_spy(etus)
int etus;
{
#ifdef SPIES
    extern double money_spy;
    extern double retire_pay;
    extern double learn_rate;
    extern short spy_retire;
    extern long spy_money[MAXNOC];
    extern long money[MAXNOC];
    enum { WORK, RESIGN, DEFECT, VANISH } plan;
    register struct spystr *spy; /* spy */
    struct spchrstr *scp;        /* spy constants pointer */
    struct shpstr *shp;		 /* ship */
    struct sctstr *sct;		 /* sector */
    struct natstr *nat;		 /* nation */
    struct plnstr *pp;		 /* plane */
    double locHLEV,locELEV,locTLEV;
    double spyHLEV,spyELEV,spyTLEV;
    natid hostcn,cn,pn;
    coord x,y;
    u_char scttype;
    int	eff,i,n,m,roaming,edelta,mxtech;
    long start_money;
    double lesson,mult,salary;

    for (n=0; spy = getspyp(n); n++) {
	if (spy->spy_own == 0) continue;

	scp = &spchr[spy->spy_type];
	spyHLEV	= (double)spy->spy_hap;
	spyELEV	= (double)spy->spy_edu;
	spyTLEV	= (double)spy->spy_tech;

	if (spy->spy_ship >= 0) {
	    if ((shp=getshipp(spy->spy_ship))==0) {
		spy->spy_own = 0; /* bad ship */
		continue;
	    }
	    spy->spy_x = shp->shp_x;
	    spy->spy_y = shp->shp_y;
	    nat = getnatp(shp->shp_own);
	    hostcn = shp->shp_own;
	    locHLEV = natHLEV;
	    locELEV = natELEV;
	    locTLEV = natTLEV;
	    scttype = 0;
	    edelta = (hostcn==spy->spy_own) 
		? shp->shp_effic * etus / 200
		    : 0;
	} else {
	    if ((sct=getsectp(spy->spy_x, spy->spy_y))==0) {
		spy->spy_own = 0; /* bad sector */
		continue;
	    }
	    nat = getnatp(sct->sct_own);
	    hostcn = sct->sct_own;
	    locHLEV = natHLEV;
	    locELEV = natELEV;
	    locTLEV = natTLEV;
	    scttype = sct->sct_type;
	    edelta = (hostcn==spy->spy_own)
		? sct->sct_effic * etus / 100
		    : sct->sct_effic * etus / 300;
	}

	roaming = (hostcn != spy->spy_own);
	nat = getnatp(spy->spy_own);
	start_money = nat->nat_money;
	if (hostcn == 0) locHLEV = natHLEV;

	/*
	**  Bump spy's age, maybe force him to retire.
	*/

	spy->spy_age++;
	if ((spy->spy_ship < 0) && (etus*spy->spy_age > spy_retire)) {
	    wu(0, spy->spy_own,
	       fmt("%s #%d retired from service with $%.2f pension\n",
		   scp->sp_name, n, retire_pay));
	    nat->nat_money -= retire_pay;
	    spy_money[spy->spy_own] += (nat->nat_money - start_money);
	    spy->spy_own = 0;
	    continue;
	}

	/*
	**  Pay the spy's salary (this is probably overly complicated).
	**  Spy gets a 20% bonus if he's extremely smart (edu), 
	**  a 15% bonus if he's extremely clever (tech), a 5% bonus
	**  if he's not in his homeland, and an additional 5% bonus
	**  if he's in non-POGO foreign land.
	**  Similarly, he gets docked 5% if he's an idiot (edu),
	**  another 5% if he's not keeping up technically (tech),
	**  and takes a 10% cut if he's overly happy.
	*/

	mult = 1.0
	    + ((natHLEV < spyHLEV*0.85) ? -0.10 : 0.0)
	    + ((spyELEV < natELEV*0.85) ? -0.05 : 0.0)
	    + ((spyTLEV < natTLEV*0.85) ? -0.05 : 0.0)
	    + ((natELEV < spyELEV*0.85) ?  0.20 : 0.0)
	    + ((natTLEV < spyTLEV*0.85) ?  0.15 : 0.0)
	    + ((roaming)                ?  0.05 : 0.0)
	    + ((hostcn && roaming)      ?  0.05 : 0.0);
	salary = -(double)(mult * etus * money_spy * scp->sp_cost/250.0);
	nat->nat_money = nat->nat_money - salary;

	/* 
	**  If spy's country is broke, reduce spy's happiness.
	*/

	if (money[spy->spy_own] < 0) {
	    spyHLEV *= (float)(100-roll(20))/100.0;
	    edelta = random() % (etus/2);
	    eff = spy->spy_effic - edelta;
	    if (eff < 10) eff = 10;
	    spy->spy_effic = eff;
	}

	/*
	**  Adjust spy's happiness toward the local happiness.
	**  If spy's on home soil, raise his tech and education rapidly.
	**  If spy's on foreign soil, he absorbs tech and education slowly.
	*/

	spyHLEV += etus*(locHLEV-spyHLEV)/15.0;
	if (spyHLEV > locHLEV) spyHLEV = locHLEV;

	if (roaming) {
	    if (spyTLEV < locTLEV) {
		spyTLEV += etus*(locTLEV-spyTLEV)*learn_rate/40.0;
		if (spyTLEV > locTLEV) spyTLEV = locTLEV;
		}
	    if (spyELEV < locELEV) {
		spyELEV += etus*(locELEV-spyELEV)*learn_rate/40.0;
		if (spyELEV > locELEV) spyELEV = locELEV;
	    }
	} else {
	    if (spyTLEV < natTLEV) {
		spyTLEV += etus*(natTLEV-spyTLEV)*learn_rate/15.0;
		if (spyTLEV > locTLEV) spyTLEV = locTLEV;
	    }
	    if (spyELEV < natELEV) {
		spyELEV += etus*(natELEV-spyELEV)*learn_rate/20.0;
		if (spyELEV > locELEV) spyELEV = locELEV;
	    }
	}

	/*
	**  Now make a career decision.
	*/

	plan = WORK;
	if (spy->spy_ship < 0) {
	    if (roaming) {
		if (spyHLEV < locHLEV*0.35)
		    plan = (chance(0.75) ? DEFECT : VANISH);
		else if (spyHLEV < locHLEV*0.65)
		    plan = (chance(0.25) ? DEFECT : WORK);
	    } else {
		if (spyHLEV < natHLEV*0.35)
		    plan = RESIGN;
	    }
	}

	switch (plan) {

	case RESIGN:
	    wu(0, spy->spy_own,
	       fmt("%s #%d resigned from service in %s\n",
		   scp->sp_name,n,xyas(sct->sct_x,sct->sct_y,spy->spy_own)));
	    spy_money[spy->spy_own] += (nat->nat_money - start_money);
	    spy->spy_own = 0;
	    continue;

	case VANISH:
	    wu(0, spy->spy_own,
	       fmt("%s #%d vanished in %s\n",scp->sp_name, n,
		   xyas(sct->sct_x,sct->sct_y,spy->spy_own)));
	    spy_money[spy->spy_own] += (nat->nat_money - start_money);
	    spy->spy_own = 0;
	    continue;

	case DEFECT:
	    wu(0, spy->spy_own,
	       fmt("%s #%d vanished in %s\n",scp->sp_name, n,
		   xyas(sct->sct_x,sct->sct_y,spy->spy_own)));
	    /* 90% chance he'll defect where he is */
	    if (chance(0.9) && roaming)
		pn = sct->sct_own;
	    else {
		/* Pick a happy country to defect to */
		pn = 0; spyHLEV = -1.0; 
		for (cn=1; cn<MAXNOC; cn++) {
		    if (cn == spy->spy_own) continue;
		    nat = getnatp(cn);
		    if ((nat->nat_stat & STAT_NORM) == 0) continue;
		    if (natHLEV > spyHLEV) {
			pn = cn; spyHLEV = natHLEV;
			if (chance(0.2)) break;
		    }
		}
	    }
	    wu(0, pn, fmt("%s %s #%d defected to you in %s\n",
			  cname(spy->spy_own),scp->sp_name, n,
			  xyas(sct->sct_x,sct->sct_y,spy->spy_own)));
	    nat = getnatp(pn);
	    spyHLEV = natHLEV;
	    spy_money[spy->spy_own] += (nat->nat_money - start_money);
	    spy->spy_oldown = spy->spy_own;
	    spy->spy_own = pn;
	    continue;

	case WORK:
	    if (spyHLEV > natHLEV*0.95) {
		spy->spy_oldown = spy->spy_own;
	    }
	    break;
	}

	/*
	**  Increase spy efficiency (also probably overly complicated).
	**  Spies in tech centers get a bonus tech gain;
	**  spies in libraries get a bonus edu gain;
	**  spies in parks get bonus hap and eff gains;
	**  spies in forts and capitols get bonus edu and eff gains.
	*/

	switch (scttype) {
	case SCT_FORTR:
	case SCT_CAPIT:
	    if (hostcn == spy->spy_own) edelta *= 2;
	    if (spyELEV < 1.1*locELEV) 
		spyELEV *= (1.02 * learn_rate);
	    break;
	case SCT_AIRPT:
	    /* find the highest aircraft tech in this sector */
	    for (m=mxtech=0; pp = getplanep(m); m++) {
		if (pp->pln_own == 0) continue;
		if (pp->pln_x!=spy->spy_x) continue;
		if (pp->pln_y!=spy->spy_y) continue;
		if (pp->pln_tech > mxtech) mxtech = pp->pln_tech;
	    }
	    if (mxtech > spy->spy_plntech) { /* flying lessons? */
		lesson = (1.0+spyELEV) * (double)etus / 3.0;
		if (hostcn != spy->spy_own) lesson /= 4.0;
		lesson *= learn_rate;
		spy->spy_plntech += (int)(lesson + 0.5);
		if (spy->spy_plntech > mxtech)
		    spy->spy_plntech = mxtech;
	    }
	    /* drop into harbor case */
	case SCT_HARBR:
	case SCT_TANK:
	    if (spyTLEV < 1.1*locTLEV) 
		spyTLEV *= (1.02 * learn_rate);
	    break;
	case SCT_TECH:
	    if (spyTLEV < 1.1*locTLEV) 
		spyTLEV *= (1.05 * learn_rate);
	    break;
	case SCT_LIBR:
	    if (spyELEV < 1.1*locELEV) 
		spyELEV *= (1.05 * learn_rate);
	    break;
	case SCT_PARK:
	    if (spyHLEV < 1.1*locHLEV)
		spyHLEV *= (1.10 * learn_rate);
	    edelta *= 2;
	    break;
	}
	eff = spy->spy_effic;
	if (edelta+eff > 100) edelta = 100-eff;
	if (edelta < 0) edelta = 0;
	if (edelta > 100) edelta = 100;
	
#ifdef NOTDEF
	wu(0, 0, fmt("%s #%d own=%d host=%d stype=%d edelta=%d salary=$%.2f\n",
		     spchr[spy->spy_uid].sp_name,spy->spy_uid,
		     spy->spy_own, hostcn, scttype, edelta, salary));
#endif

	spy->spy_effic += edelta;
	if (spy->spy_effic < 0) spy->spy_effic = 0;
	if (spy->spy_effic > 100) spy->spy_effic = 100;

	wu(0, spy->spy_own,
	   fmt("%s #%d expenses $%.2f (hap %s%.1f edu %s%.1f tech %s%.1f)\n",
	       scp->sp_name, n, salary,
	       (spyHLEV >= spy->spy_hap)  ? "+" : "", spyHLEV - spy->spy_hap,
	       (spyELEV >= spy->spy_edu)  ? "+" : "", spyELEV - spy->spy_edu,
	       (spyTLEV >= spy->spy_tech) ? "+" : "", spyTLEV - spy->spy_tech
	       ));

	spy_money[spy->spy_own] += (nat->nat_money - start_money);
	spy->spy_hap = spyHLEV;
	spy->spy_edu = spyELEV;
	spy->spy_tech = spyTLEV;
    }
#endif
}
